function goToLoginPage() {
    if (mainView !== null) {
        mainView.router.navigate('/login/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    loginPageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/login/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    loginPageInit();
                }
            }
        });
    }
}

function goToConfirmPage(mobile) {
    if (mainView !== null) {
        mainView.router.navigate('/confirm-code/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    confirmPageInit(mobile);
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/confirm-code/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    confirmPageInit(mobile);
                }
            }
        });
    }
}

function goToLocationAccessPage() {
    if (mainView !== null) {
        app.views.main.router.navigate('/location/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    locationPageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/location/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    locationPageInit();
                }
            }
        });
    }
}

function goToHomePage(lat, lng, locationName) {
        if (mainView !== null) {
            app.views.main.router.navigate('/', {
                pushState: true,
                on: {
                    pageInit: function (page) {
                        // console.log('call to homePageInit not null');
                        if (page.name === 'home') {
                            homePageInit(lat, lng, locationName, page)
                        }
                    }
                }
            });
        } else {
            mainView = app.views.create('.view-main', {
                url: '/',
                pushState: true,
                on: {
                    pageInit: function (page) {
                        if (page.name === 'home') {
                            homePageInit(lat, lng, locationName, page);
                        }
                    }
                }
            });
        }
}

async function goToCartPage(foodMenu, storageAppetizer) {

    if(foodMenu == '' || foodMenu == undefined || foodMenu == null || foodMenu == 'null' || foodMenu == false) {
        let storageLat = window.localStorage.getItem("lat");
        let storageLng = window.localStorage.getItem("lng");

        let menu = new Menu();

        await menu.getMenuData(storageLat, storageLng);
        foodMenu = menu.menuList;
        app.preloader.hide();
    }

    if (mainView !== null) {
        mainView.router.navigate('/cart/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    cartPageInit(foodMenu, storageAppetizer, page)
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/cart/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    cartPageInit(foodMenu, storageAppetizer, page);
                }
            }
        });
    }

}

async function getLocationAccessMobile(isFromLocationPage=false) {

    // let storageLat = window.localStorage.getItem("lat");
    // let storageLng = window.localStorage.getItem("lng");
    var storageSelectedAddress = window.localStorage.getItem("selectedAddress");
    var locationUpdateTimestamp = window.localStorage.getItem("locationUpdateTimestamp");
    let now = Math.round(new Date().getTime()/1000);
    let diffTime = now - locationUpdateTimestamp;
    let aDayInSeconds = 86400;

    if(locationUpdateTimestamp != undefined && locationUpdateTimestamp != '' && locationUpdateTimestamp != null && diffTime < aDayInSeconds) {

        locationForHomePageInit(user, true, function (lat, lon, name) {
            goToHomePage(lat, lon, name);
        });

        // let fullLocationName = await user.getUserLocationName(storageLat, storageLng);
        // let lName = await getLocationName(fullLocationName);
        //
        //
        // if(storageSelectedAddress != undefined && storageSelectedAddress != '' && storageSelectedAddress != null
        //     && storageSelectedAddress != 0) {
        //
        //     let locationData = await locationForHomePageInit(user);
        //     let lat = locationData[0];
        //     let lng = locationData[1];
        //     let locationName = locationData[2];
        //
        //     console.log('address entekhab karde');
        //     console.log(lName);
        //
        //     console.log(lat);
        //     console.log(lng);
        //     console.log(locationName);
        //
        //     // address
        //
        // } else {
        //
        //     console.log('search karde');
        //     console.log(lName);
        //
        // }

    } else {
        navigator.geolocation.getCurrentPosition(function(position) {

            window.localStorage.setItem("lat", position.coords.latitude);
            window.localStorage.setItem("lng", position.coords.longitude);

            locationForHomePageInit(user, true, function (lat, lon, name) {
                goToHomePage(lat, lon, name);
            });

        }, function() {

            locationForHomePageInit(user, true, function (lat, lon, name) {
                goToHomePage(lat, lon, name);
            });

        }, {
            timeout: 5000,
        });
    }

}

async function goToChooseAddressPage(cart, foodMenu, availableAddresses=false) {

    $$('.cart-page-next-btn a').html('انتخاب آدرس');
    $$('.go-to-purchase').html('پرداخت');
    $$('.cart-page-next-btn').css('pointer-events', 'all');

    if(foodMenu == '' || foodMenu == undefined || foodMenu == null || foodMenu == 'null' || foodMenu == false) {
        let storageLat = window.localStorage.getItem("lat");
        let storageLng = window.localStorage.getItem("lng");

        let menu = new Menu();

        await menu.getMenuData(storageLat, storageLng);
        foodMenu = menu.menuList;
        app.preloader.hide();
    }

    if (mainView !== null) {

        mainView.router.navigate('/choose-address/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    chooseAddressPageInit(cart, foodMenu, availableAddresses)
                }
            }
        });
    } else {

        mainView = app.views.create('.view-main', {
            url: '/choose-address/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    chooseAddressPageInit(cart, foodMenu, availableAddresses);
                }
            }
        });
    }
}

function goToPurchasePage(cart, foodMenu, storageAppetizer) {
    if (mainView !== null) {
        mainView.router.navigate('/purchase/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    purchasePageInit(cart, foodMenu, storageAppetizer)
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/purchase/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    purchasePageInit(cart, foodMenu, storageAppetizer);
                }
            }
        });
    }
}

function goToAddressPage(storageLat, storageLng) {
    if (mainView !== null) {
        mainView.router.navigate('/address/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    addressPageInit(storageLat, storageLng)
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/address/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    addressPageInit(storageLat, storageLng);
                }
            }
        });
    }
}

function goToInvoicesPage() {
    if (mainView !== null) {
        mainView.router.navigate('/invoices/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    invoicesPageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/invoices/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    invoicesPageInit()
                }
            }
        });
    }
}

function goToSingleInvoice(itemId) {
    if (mainView !== null) {
        mainView.router.navigate('/invoice-status/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    singleInvoicePageInit(itemId)
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/invoice-status/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    singleInvoicePageInit(itemId)
                }
            }
        });
    }
}

function handleLoginBtnUi() {
    $$(document).on("change paste keyup", 'input.mobile-check-count', function(){
        let phoneCount = $$(this).val().length;

        if( phoneCount > 9 && phoneCount < 12) {
            $$('.btn-login').addClass('btn-on');
            $$('.btn-login').removeAttr('disabled');
        } else {
            $$('.btn-login').removeClass('btn-on');
            $$('.btn-login').attr('disabled', '');
        }
    });
    // $$('input.mobile-check-count').on("change paste keyup", function() {
    //     let phoneCount = $$(this).val().length;
    //     alert(phoneCount);
    //     if( phoneCount > 9 && phoneCount < 12) {
    //         $$('.btn-login').addClass('btn-on');
    //         $$('.btn-login').removeAttr('disabled');
    //     } else {
    //         $$('.btn-login').removeClass('btn-on');
    //         $$('.btn-login').attr('disabled', '');
    //     }
    // });
}

function handleLoginBtnClick() {
    $$('a.btn-login').on('click', function () {
        preparingMobileAndSend();
    });

    $$('#mobile-form').keypress(function (e) {
        var key = e.which;
        if(key == 13)  // the enter key code
        {
            preparingMobileAndSend();
        }
    });
}

function sendAgainCodeTimer() {

    $$('.resend-code').hide();

    $$('.resend-timer').show();

    let n = $$('.codeTimer').attr('id');
    let c = n;

    $$('.codeTimer').text('');
    let interval = setInterval(function(){
        c--;
        if(c>=0){
            $$('.codeTimer').text(c);
            $$('.change-mobile').click(function(){
                clearInterval(interval);
            });
        }
        if(c==0){
            $$('.codeTimer').text('');
            $$('.resend-code').show();
            $$('.resend-timer').hide();
            $$('.resend-code').css('pointer-events', 'all');
        }
    },1000);
}

function handleConfirmCodeInputs(mobile) {
    $$('.firstCodeInput').focus();

    let domPlatform = $$('html').hasClass('ios');

    if(platform != 'ios' && domPlatform != true) {
        $$('.iosInputBox').hide();

        $$('.code-inputs').on('change paste keyup', function() {


            // if(platform != 'ios') {
                if (this.value.length == this.maxLength) {
                    $$(this).next('.code-inputs').focus();
                }
            // }

            let codeStr = '';

            $$('.code-inputs').each(function () {

                codeStr = codeStr.concat($$(this).val());
                if(codeStr.length == 5) {
                    $$('.inputs-box').addClass('blur-loading');
                    let codeStrEn = convertToEnglish(codeStr);
                    user.confirmCode(mobile, codeStrEn, function (response) {
                        $$('.inputs-box').removeClass('blur-loading');
                        if(response['code'] === 100) {
                            window.localStorage.setItem("confirmationToken", response['confirmationToken']);

                            refreshApp();

                            $$('.code-inputs').val('');
                        } else {
                            $$('.code-inputs').val('');
                            $$("#firstCodeInput").focus();

                            confirmCodeError.open();
                        }
                    });
                }
            });
        });

        // if(platform != 'ios') {
            $('.code-inputs').keydown(function (e) {
                if ((e.which == 8 || e.which == 46) && $(this).val() == '') {
                    $(this).prev('input').focus();
                }
            });
        // }
    } else {
        $$('.web-inputBox').hide();
        $$('.iosInputBox').show();

        $$(document).on('change paste keyup', '.code-inputs', function() {


            // if(platform != 'ios') {
            //     if (this.value.length == this.maxLength) {
            //         $$(this).next('.code-inputs').focus();
            //     }
            // }

            let codeStr = '';

            $$('.code-inputs').each(function () {

                codeStr = codeStr.concat($$(this).val());
                if(codeStr.length == 5) {
                    $$('.inputs-box').addClass('blur-loading');
                    let codeStrEn = convertToEnglish(codeStr);
                    user.confirmCode(mobile, codeStrEn, function (response) {
                        $$('.inputs-box').removeClass('blur-loading');
                        if(response['code'] === 100) {
                            window.localStorage.setItem("confirmationToken", response['confirmationToken']);

                            refreshApp();

                            $$('.code-inputs').val('');
                        } else {
                            $$('.code-inputs').val('');
                            $$("#firstCodeInput").focus();

                            confirmCodeError.open();
                        }
                    });
                }
            });
        });
    }
}

function getLocation() {

    window.localStorage.setItem("locationAccess", true);

    if (navigator.geolocation) {

        navigator.geolocation.getCurrentPosition(showPosition,showError);

    } else {

        refreshApp();
    }

    function showPosition(position) {

        let lat  = position.coords.latitude;
        let lng = position.coords.longitude;

        window.localStorage.setItem("lat", lat);
        window.localStorage.setItem("lng", lng);

        refreshApp();
    }

    function showError(error) {

        window.localStorage.setItem("lat", '');
        window.localStorage.setItem("lng", '');

        switch(error.code) {
            case error.PERMISSION_DENIED:
                // console.log("User denied the request for Geolocation.");
                break;
            case error.POSITION_UNAVAILABLE:
                // console.log("Location information is unavailable.");
                break;
            case error.TIMEOUT:
                // console.log("The request to get user location timed out.");
                break;
            case error.UNKNOWN_ERROR:
                // console.log("An unknown error occurred.");
                break;
        }

        refreshApp();

    }

}

function renderLocationName(locationName) {

    if (locationName !== '' && locationName !== undefined && locationName.length > 0) {

        $$('.location-name').empty();
        $$('.location-name').append(locationName);

    } else {

        $$('.location-name').empty();
        $$('.location-name').append('انتخاب محله');

    }
}

function renderLocationNameInNavbar(locationName) {

    if (locationName !== '' && locationName !== undefined && locationName.length > 0) {

        locationName = locationName.replace("محله", "");

        if(locationName.length>17) {
            locationName = locationName.substr(0,17 ) + '...';
        }

        $$('.location-name').empty();
        $$('.location-name').append(locationName);

    } else {

        $$('.location-name').empty();
        $$('.location-name').append('انتخاب محله');

    }
}

function cartItemHeightHandle() {
    let cartItem = $$('body .side-cart .food-item');
    let cartItemWidth = cartItem.width() + 'px';
    cartItem.css('height', ''+ cartItemWidth +'');

    let appetizerItem = $$('body .side-cart .appetizer-item');
    let appetizerItemWidth = appetizerItem.width() + 'px';
    appetizerItem.css('height', ''+ appetizerItemWidth +'');
}

function renderFoodMenu(foodMenu) {

    let storageCart = JSON.parse(window.localStorage.getItem("cart"));

    if (storageCart == null || storageCart == undefined) {
        storageCart = [];
    }

    let menuCatOne = []; // آش
    let menuCatTwo = []; // حلیم
    let menuCatThree = []; // کله پاچه
    let menuCatFour = []; // عدسی
    let menuCatFive = []; // دیزی

    Object.keys(foodMenu).forEach(function(key) {

        var food = foodMenu[key][0];

        if (food.cat === 'آش') {
            menuCatOne.push(food);
        }

        if (food.cat === 'حلیم') {
            menuCatTwo.push(food);
        }

        if (food.cat === 'کله پاچه') {
            menuCatThree.push(food);
        }

        if (food.cat === 'عدسی') {
            menuCatFour.push(food);
        }

        if (food.cat === 'دیزی') {
            menuCatFive.push(food);
        }

    });

    let foodContainer = $$('#foods-container');

    if(menuCatOne.length > 0) {
        var menuCatOneTitleHtml = '<div class="col-100"><h2 class="category-title">آش</h2></div>';
    } else {
        var menuCatOneTitleHtml = '';
    }

    if(menuCatTwo.length > 0) {
        var menuCatTwoTitleHtml = '<div class="col-100"><h2 class="category-title">حلیم</h2></div>';
    } else {
        var menuCatTwoTitleHtml = '';
    }

    if(menuCatThree.length > 0) {
        var menuCatThreeTitleHtml = '<div class="col-100"><h2 class="category-title">کله‌پاچه</h2></div>';
    } else {
        var menuCatThreeTitleHtml = '';
    }

    if(menuCatFour.length > 0) {
        var menuCatFourTitleHtml = '<div class="col-100"><h2 class="category-title">سایر</h2></div>';
    } else {
        var menuCatFourTitleHtml = '';
    }

    if(menuCatFive.length > 0) {
        var menuCatFiveTitleHtml = '<div class="col-100"><h2 class="category-title">دیزی</h2></div>';
    } else {
        var menuCatFiveTitleHtml = '';
    }

    let menuOneHtml = '';
    let menuTwoHtml = '';
    let menuThreeHtml = '';
    let menuFourHtml = '';
    let menuFiveHtml = '';

    Object.keys(menuCatOne).forEach(function(key) {

        var menuCatOneItem = menuCatOne[key];

        var foodName = (menuCatOneItem['name'] !== undefined && menuCatOneItem['name'] !== '') ? menuCatOneItem['name'] : 'بدون عنوان';
        var foodId = (menuCatOneItem['id'] !== undefined && menuCatOneItem['id'] !== '') ? menuCatOneItem['id'] : '';
        var foodPrice = (menuCatOneItem['price'] !== undefined && menuCatOneItem['price'] !== '') ? menuCatOneItem['price'] : '-';
        var foodPriceWithOff = (menuCatOneItem['priceWithOff'] !== undefined && menuCatOneItem['priceWithOff'] !== '') ? menuCatOneItem['priceWithOff'] : '-';
        var foodContent = (menuCatOneItem['ingredients'] !== undefined && menuCatOneItem['ingredients'] !== '') ? menuCatOneItem['ingredients'] : '-';
        var foodImage = (menuCatOneItem['picture'] !== undefined && menuCatOneItem['picture'] !== '') ? menuCatOneItem['picture'] : 'img/food-item.png';
        var foodLimitPerInvoice = (menuCatOneItem['limitPerInvoice'] !== undefined && menuCatOneItem['limitPerInvoice'] !== '') ? menuCatOneItem['limitPerInvoice'] : '50';
        var foodStock = (menuCatOneItem['stock'] !== undefined && menuCatOneItem['stock'] !== '') ? menuCatOneItem['stock'] : '50';
        var foodRestId = (menuCatOneItem['restaurantId'] !== undefined && menuCatOneItem['restaurantId'] !== '') ? menuCatOneItem['restaurantId'] : '';

        if (foodStock === null) foodStock = 50;

        if (parseInt(foodPrice) === parseInt(foodPriceWithOff)) {
            var off = '';
            var finalPrice = foodPrice;
            var offBox = '';
        } else {
            var off = 'foodWithOff';
            var finalPrice = foodPriceWithOff;
            var offPercent = Math.round(100 - ((foodPriceWithOff/foodPrice) * 100) );
            var offBox = '<div class="offBox"><del>'+ foodPrice.toString().formatPrice() +' تومان </del><div class="offPercentSide"><div class="offPercent">%' + offPercent.toString().formatPrice() + '</div></div></div>';
        }

        var flag = 0;
        Object.keys(storageCart).forEach(function(j){
            if(storageCart[j] != null) {
                var storageFoodItem = storageCart[j];

                // console.log(storageCart[j])
                var storageFoodId = storageFoodItem.id;
                var storageFoodCount = storageFoodItem.count;


                if(storageFoodId == foodId && flag == 0) {
                    // foodStock = parseInt(foodStock) - parseInt(storageFoodCount);

                    flag = 1;
                }
            }
        });

        if(foodStock >= 0) {
            menuOneHtml += '<div class="col-100 desktop-50 food-item '+ off +'" data-count="1" data-stock="'+ foodStock +'" ' +
                'data-limit-per-invoice="'+ foodLimitPerInvoice +'" data-title="'+ foodName +'" data-image="'+ foodImage +'" ' +
                'data-id="'+ foodId +'" data-price="'+ foodPrice +'" data-price-with-off="'+ foodPriceWithOff +'" ' +
                'data-content="'+ foodContent +'" data-restId="'+ foodRestId +'" style="background-image: url(\''+ foodImage +'\');">' +
                '<div class="col-100 food-data"><div class="row no-gap"><div class="col-50 p-10">' +
                '<h3 class="food-title">' + foodName + '</h3>' +
                '<p class="food-detail">'+ foodContent +'</p></div><div class="col-50 p-10 text-left p-relative">' +
                '<span class="price">' + finalPrice.toString().formatPrice() + ' تومان</span>' +
                offBox +
                '<a href="" class="add-to-cart"><img src="img/food-plus-icon.svg" alt="" /></a></div></div></div></div>';
        }
    });
    Object.keys(menuCatTwo).forEach(function(key) {

        var menuCatTwoItem = menuCatTwo[key];

        var foodName = (menuCatTwoItem['name'] !== undefined && menuCatTwoItem['name'] !== '') ? menuCatTwoItem['name'] : 'بدون عنوان';
        var foodId = (menuCatTwoItem['id'] !== undefined && menuCatTwoItem['id'] !== '') ? menuCatTwoItem['id'] : '';
        var foodPrice = (menuCatTwoItem['price'] !== undefined && menuCatTwoItem['price'] !== '') ? menuCatTwoItem['price'] : '-';
        var foodPriceWithOff = (menuCatTwoItem['priceWithOff'] !== undefined && menuCatTwoItem['priceWithOff'] !== '') ? menuCatTwoItem['priceWithOff'] : '-';
        var foodContent = (menuCatTwoItem['ingredients'] !== undefined && menuCatTwoItem['ingredients'] !== '') ? menuCatTwoItem['ingredients'] : '-';
        var foodImage = (menuCatTwoItem['picture'] !== undefined && menuCatTwoItem['picture'] !== '') ? menuCatTwoItem['picture'] : 'img/food-item.png';
        var foodLimitPerInvoice = (menuCatTwoItem['limitPerInvoice'] !== undefined && menuCatTwoItem['limitPerInvoice'] !== '') ? menuCatTwoItem['limitPerInvoice'] : '50';
        var foodStock = (menuCatTwoItem['stock'] !== undefined && menuCatTwoItem['stock'] !== '') ? menuCatTwoItem['stock'] : '50';
        var foodRestId = (menuCatTwoItem['restaurantId'] !== undefined && menuCatTwoItem['restaurantId'] !== '') ? menuCatTwoItem['restaurantId'] : '';

        if (foodStock === null) foodStock = 50;

        if (parseInt(foodPrice) === parseInt(foodPriceWithOff)) {
            var off = '';
            var finalPrice = foodPrice;
            var offBox = '';
        } else {
            var off = 'foodWithOff';
            var finalPrice = foodPriceWithOff;
            var offPercent = Math.round(100 - ((foodPriceWithOff/foodPrice) * 100) );
            var offBox = '<div class="offBox"><del>'+ foodPrice.toString().formatPrice() +' تومان </del><div class="offPercentSide"><div class="offPercent">%' + offPercent + '</div></div></div>';
        }

        var flag = 0;
        Object.keys(storageCart).forEach(function(j){
            if(storageCart[j] != null) {
                var storageFoodItem = storageCart[j];

                // console.log(storageCart[j])
                var storageFoodId = storageFoodItem.id;
                var storageFoodCount = storageFoodItem.count;


                if (storageFoodId == foodId && flag == 0) {
                    foodStock = parseInt(foodStock) - parseInt(storageFoodCount);

                    flag = 1;
                }
            }
        });

        if(foodStock >= 0) {
            menuTwoHtml += '<div class="col-100 desktop-50 food-item ' + off + '" data-count="1" data-stock="' + foodStock + '" ' +
                'data-limit-per-invoice="' + foodLimitPerInvoice + '" data-title="' + foodName + '" data-image="' + foodImage + '" ' +
                'data-id="' + foodId + '" data-price="' + foodPrice + '" data-price-with-off="' + foodPriceWithOff + '" ' +
                'data-content="' + foodContent + '" data-restId="' + foodRestId + '" style="background-image: url(\''+ foodImage +'\');">' +
                '<div class="col-100 food-data"><div class="row no-gap"><div class="col-50 p-10">' +
                '<h3 class="food-title">' + foodName + '</h3>' +
                '<p class="food-detail">' + foodContent + '</p></div><div class="col-50 p-10 text-left p-relative">' +
                '<span class="price">' + finalPrice.toString().formatPrice() + ' تومان</span>' +
                offBox +
                '<a href="" class="add-to-cart"><img src="img/food-plus-icon.svg" alt="" /></a></div></div></div></div>';
        }
    });
    // console.log(menuCatThree);
    Object.keys(menuCatThree).forEach(function(key) {

        var menuCatThreeItem = menuCatThree[key];

        var foodName = (menuCatThreeItem['name'] !== undefined && menuCatThreeItem['name'] !== '') ? menuCatThreeItem['name'] : 'بدون عنوان';
        var foodId = (menuCatThreeItem['id'] !== undefined && menuCatThreeItem['id'] !== '') ? menuCatThreeItem['id'] : '';
        var foodPrice = (menuCatThreeItem['price'] !== undefined && menuCatThreeItem['price'] !== '') ? menuCatThreeItem['price'] : '-';
        var foodPriceWithOff = (menuCatThreeItem['priceWithOff'] !== undefined && menuCatThreeItem['priceWithOff'] !== '') ? menuCatThreeItem['priceWithOff'] : '-';
        var foodContent = (menuCatThreeItem['ingredients'] !== undefined && menuCatThreeItem['ingredients'] !== '') ? menuCatThreeItem['ingredients'] : '-';
        var foodImage = (menuCatThreeItem['picture'] !== undefined && menuCatThreeItem['picture'] !== '') ? menuCatThreeItem['picture'] : 'img/food-item.png';
        var foodLimitPerInvoice = (menuCatThreeItem['limitPerInvoice'] !== undefined && menuCatThreeItem['limitPerInvoice'] !== '') ? menuCatThreeItem['limitPerInvoice'] : '50';
        var foodStock = (menuCatThreeItem['stock'] !== undefined && menuCatThreeItem['stock'] !== '') ? menuCatThreeItem['stock'] : '50';
        var foodRestId = (menuCatThreeItem['restaurantId'] !== undefined && menuCatThreeItem['restaurantId'] !== '') ? menuCatThreeItem['restaurantId'] : '';

        if (foodStock === null) foodStock = 50;

        if (parseInt(foodPrice) === parseInt(foodPriceWithOff)) {
            var off = '';
            var finalPrice = foodPrice;
            var offBox = '';
        } else {
            var off = 'foodWithOff';
            var finalPrice = foodPriceWithOff;
            var offPercent = Math.round(100 - ((foodPriceWithOff/foodPrice) * 100) );
            var offBox = '<div class="offBox"><del>'+ foodPrice.toString().formatPrice() +' تومان </del><div class="offPercentSide"><div class="offPercent">%' + offPercent + '</div></div></div>';
        }

        var flag = 0;
        Object.keys(storageCart).forEach(function(j){
            if(storageCart[j] != null) {
                var storageFoodItem = storageCart[j];

                // console.log(storageCart[j])
                var storageFoodId = storageFoodItem.id;
                var storageFoodCount = storageFoodItem.count;


                if (storageFoodId == foodId && flag == 0) {
                    foodStock = parseInt(foodStock) - parseInt(storageFoodCount);

                    flag = 1;
                }
            }
        });

        if(foodStock >= 0) {
            menuThreeHtml += '<div class="col-100 desktop-50 food-item ' + off + '" data-count="1" data-stock="' + foodStock + '" ' +
                'data-limit-per-invoice="' + foodLimitPerInvoice + '" data-title="' + foodName + '" data-image="' + foodImage + '" ' +
                'data-id="' + foodId + '" data-price="' + foodPrice + '" data-price-with-off="' + foodPriceWithOff + '" ' +
                'data-content="' + foodContent + '" data-restId="' + foodRestId + '" style="background-image: url(\''+ foodImage +'\');">' +
                '<div class="col-100 food-data"><div class="row no-gap"><div class="col-50 p-10">' +
                '<h3 class="food-title">' + foodName + '</h3>' +
                '<p class="food-detail">' + foodContent + '</p></div><div class="col-50 p-10 text-left p-relative">' +
                '<span class="price">' + finalPrice.toString().formatPrice() + ' تومان</span>' +
                offBox +
                '<a href="" class="add-to-cart"><img src="img/food-plus-icon.svg" alt="" /></a></div></div></div></div>';
        }
    });
    Object.keys(menuCatFour).forEach(function(key) {

        var menuCatFourItem = menuCatFour[key];

        var foodName = (menuCatFourItem['name'] !== undefined && menuCatFourItem['name'] !== '') ? menuCatFourItem['name'] : 'بدون عنوان';
        var foodId = (menuCatFourItem['id'] !== undefined && menuCatFourItem['id'] !== '') ? menuCatFourItem['id'] : '';
        var foodPrice = (menuCatFourItem['price'] !== undefined && menuCatFourItem['price'] !== '') ? menuCatFourItem['price'] : '-';
        var foodPriceWithOff = (menuCatFourItem['priceWithOff'] !== undefined && menuCatFourItem['priceWithOff'] !== '') ? menuCatFourItem['priceWithOff'] : '-';
        var foodContent = (menuCatFourItem['ingredients'] !== undefined && menuCatFourItem['ingredients'] !== '') ? menuCatFourItem['ingredients'] : '-';
        var foodImage = (menuCatFourItem['picture'] !== undefined && menuCatFourItem['picture'] !== '') ? menuCatFourItem['picture'] : 'img/food-item.png';
        var foodLimitPerInvoice = (menuCatFourItem['limitPerInvoice'] !== undefined && menuCatFourItem['limitPerInvoice'] !== '') ? menuCatFourItem['limitPerInvoice'] : '50';
        var foodStock = (menuCatFourItem['stock'] !== undefined && menuCatFourItem['stock'] !== '') ? menuCatFourItem['stock'] : '50';
        var foodRestId = (menuCatFourItem['restaurantId'] !== undefined && menuCatFourItem['restaurantId'] !== '') ? menuCatFourItem['restaurantId'] : '';

        if (foodStock === null) foodStock = 50;

        if (parseInt(foodPrice) === parseInt(foodPriceWithOff)) {
            var off = '';
            var finalPrice = foodPrice;
            var offBox = '';
        } else {
            var off = 'foodWithOff';
            var finalPrice = foodPriceWithOff;
            var offPercent = Math.round(100 - ((foodPriceWithOff/foodPrice) * 100) );
            var offBox = '<div class="offBox"><del>'+ foodPrice.toString().formatPrice() +' تومان </del><div class="offPercentSide"><div class="offPercent">%' + offPercent + '</div></div></div>';
        }

        var flag = 0;
        Object.keys(storageCart).forEach(function(j){
            if(storageCart[j] != null) {
                var storageFoodItem = storageCart[j];

                // console.log(storageCart[j])
                var storageFoodId = storageFoodItem.id;
                var storageFoodCount = storageFoodItem.count;


                if (storageFoodId == foodId && flag == 0) {
                    foodStock = parseInt(foodStock) - parseInt(storageFoodCount);

                    flag = 1;
                }
            }
        });

        if(foodStock >= 0) {
            menuFourHtml += '<div class="col-100 desktop-50 food-item ' + off + '" data-count="1" data-stock="' + foodStock + '" ' +
                'data-limit-per-invoice="' + foodLimitPerInvoice + '" data-title="' + foodName + '" data-image="' + foodImage + '" ' +
                'data-id="' + foodId + '" data-price="' + foodPrice + '" data-price-with-off="' + foodPriceWithOff + '" ' +
                'data-content="' + foodContent + '" data-restId="' + foodRestId + '" style="background-image: url(\''+ foodImage +'\');">' +
                '<div class="col-100 food-data"><div class="row no-gap"><div class="col-50 p-10">' +
                '<h3 class="food-title">' + foodName + '</h3>' +
                '<p class="food-detail">' + foodContent + '</p></div><div class="col-50 p-10 text-left p-relative">' +
                '<span class="price">' + finalPrice.toString().formatPrice() + ' تومان</span>' +
                offBox +
                '<a href="" class="add-to-cart"><img src="img/food-plus-icon.svg" alt="" /></a></div></div></div></div>';
        }
    });
    Object.keys(menuCatFive).forEach(function(key) {

        var menuCatFiveItem = menuCatFive[key];

        var foodName = (menuCatFiveItem['name'] !== undefined && menuCatFiveItem['name'] !== '') ? menuCatFiveItem['name'] : 'بدون عنوان';
        var foodId = (menuCatFiveItem['id'] !== undefined && menuCatFiveItem['id'] !== '') ? menuCatFiveItem['id'] : '';
        var foodPrice = (menuCatFiveItem['price'] !== undefined && menuCatFiveItem['price'] !== '') ? menuCatFiveItem['price'] : '-';
        var foodPriceWithOff = (menuCatFiveItem['priceWithOff'] !== undefined && menuCatFiveItem['priceWithOff'] !== '') ? menuCatFiveItem['priceWithOff'] : '-';
        var foodContent = (menuCatFiveItem['ingredients'] !== undefined && menuCatFiveItem['ingredients'] !== '') ? menuCatFiveItem['ingredients'] : '-';
        var foodImage = (menuCatFiveItem['picture'] !== undefined && menuCatFiveItem['picture'] !== '') ? menuCatFiveItem['picture'] : 'img/food-item.png';
        var foodLimitPerInvoice = (menuCatFiveItem['limitPerInvoice'] !== undefined && menuCatFiveItem['limitPerInvoice'] !== '') ? menuCatFiveItem['limitPerInvoice'] : '50';
        var foodStock = (menuCatFiveItem['stock'] !== undefined && menuCatFiveItem['stock'] !== '') ? menuCatFiveItem['stock'] : '50';
        var foodRestId = (menuCatFiveItem['restaurantId'] !== undefined && menuCatFiveItem['restaurantId'] !== '') ? menuCatFiveItem['restaurantId'] : '';

        if (foodStock === null) foodStock = 50;

        if (parseInt(foodPrice) === parseInt(foodPriceWithOff)) {
            var off = '';
            var finalPrice = foodPrice;
            var offBox = '';
        } else {
            var off = 'foodWithOff';
            var finalPrice = foodPriceWithOff;
            var offPercent = Math.round(100 - ((foodPriceWithOff/foodPrice) * 100) );
            var offBox = '<div class="offBox"><del>'+ foodPrice.toString().formatPrice() +' تومان </del><div class="offPercentSide"><div class="offPercent">%' + offPercent + '</div></div></div>';
        }

        var flag = 0;
        Object.keys(storageCart).forEach(function(j){
            if(storageCart[j] != null) {
                var storageFoodItem = storageCart[j];

                // console.log(storageCart[j])
                var storageFoodId = storageFoodItem.id;
                var storageFoodCount = storageFoodItem.count;


                if (storageFoodId == foodId && flag == 0) {
                    foodStock = parseInt(foodStock) - parseInt(storageFoodCount);

                    flag = 1;
                }
            }
        });

        if(foodStock >= 0) {
            menuFiveHtml += '<div class="col-100 desktop-50 food-item ' + off + '" data-count="1" data-stock="' + foodStock + '" ' +
                'data-limit-per-invoice="' + foodLimitPerInvoice + '" data-title="' + foodName + '" data-image="' + foodImage + '" ' +
                'data-id="' + foodId + '" data-price="' + foodPrice + '" data-price-with-off="' + foodPriceWithOff + '" ' +
                'data-content="' + foodContent + '" data-restId="' + foodRestId + '" style="background-image: url(\''+ foodImage +'\');">' +
                '<div class="col-100 food-data"><div class="row no-gap"><div class="col-50 p-10">' +
                '<h3 class="food-title">' + foodName + '</h3>' +
                '<p class="food-detail">' + foodContent + '</p></div><div class="col-50 p-10 text-left p-relative">' +
                '<span class="price">' + finalPrice.toString().formatPrice() + ' تومان</span>' +
                offBox +
                '<a href="" class="add-to-cart"><img src="img/food-plus-icon.svg" alt="" /></a></div></div></div></div>';
        }
    });

    foodContainer.empty();

    foodContainer.append(menuCatOneTitleHtml, menuOneHtml, menuCatTwoTitleHtml, menuTwoHtml, menuCatThreeTitleHtml, menuThreeHtml, menuCatFourTitleHtml, menuFourHtml, menuCatFiveTitleHtml, menuFiveHtml);
}

async function renderCartList(cartList, foodMenu, cart) {

    if(foodMenu == '' || foodMenu == null || foodMenu == undefined || foodMenu == []) {
        cartList = [];
    }

    let cartContainer = $$('#cart-container');

    if (cartList != '' && cartList != null && cartList != undefined && cartList != []) {
        $$('img.empty-cart').hide();

        let cartHtml = '';

        Object.keys(cartList).forEach(function(k) {
            if(cartList[k] != null) {
                let storageCartFoodItem = cartList[k];

                var storageCartFoodItemName = (storageCartFoodItem['name'] !== undefined && storageCartFoodItem['name'] !== '') ? storageCartFoodItem['name'] : 'بدون عنوان';
                var storageCartFoodItemPrice = (storageCartFoodItem['price'] !== undefined && storageCartFoodItem['price'] !== '') ? storageCartFoodItem['price'] : '';
                var storageCartFoodItemPriceWithOff = (storageCartFoodItem['priceWithOff'] !== undefined && storageCartFoodItem['priceWithOff'] !== '') ? storageCartFoodItem['priceWithOff'] : '';
                var storageCartFoodItemCount = (storageCartFoodItem['count'] !== undefined && storageCartFoodItem['count'] !== '' && storageCartFoodItem['count'] !== null) ? storageCartFoodItem['count'] : '1';
                var storageCartFoodItemId = (storageCartFoodItem['id'] !== undefined && storageCartFoodItem['id'] !== '' && storageCartFoodItem['id'] !== null) ? storageCartFoodItem['id'] : '';
                var storageCartFoodItemImage = (storageCartFoodItem['image'] !== undefined && storageCartFoodItem['image'] !== '') ? storageCartFoodItem['image'] : 'img/food-item.png';

                var flag = 0;
                Object.keys(foodMenu).forEach(function(j) {

                    let foodMenuFoodItem = foodMenu[j][0];
                    var foodMenuFoodItemId = foodMenuFoodItem['id'];

                    if( flag == 0) {
                        if (parseInt(storageCartFoodItemId) === parseInt(foodMenuFoodItemId)) {

                            cartHtml += '<div class="col-100 food-item cart-item animated pulse" data-count="'+ storageCartFoodItemCount +'"' +
                                'data-name="'+ storageCartFoodItemName +'" data-price="'+ storageCartFoodItemPrice +'" data-id="'+ storageCartFoodItemId +'" ' +
                                'data-price-with-off="'+ storageCartFoodItemPriceWithOff +'" style="background-image: url(\''+ storageCartFoodItemImage +'\');">' +
                                '<div class="col-100 food-data">' +
                                '<div class="row no-gap">' +
                                '<div class="col-100 cart-food-title">' +
                                '<h3 class="food-title">' + storageCartFoodItemName +
                                '</h3>' +
                                '</div>' +
                                '</div>' +
                                '</div><div class="cart-minus"><img src="img/minus.svg" alt="" /></div>' +
                                '<div class="cart-item-counter">'+ storageCartFoodItemCount +'</div></div>';

                            flag = 1;
                        }
                    }
                });
                if(flag == 0) {
                    cartHtml += '<div class="col-100 food-item cart-item no-stock animated pulse" data-count="'+ storageCartFoodItemCount +'"' +
                        'data-name="'+ storageCartFoodItemName +'" data-price="'+ storageCartFoodItemPrice +'" data-id="'+ storageCartFoodItemId +'" ' +
                        'data-price-with-off="'+ storageCartFoodItemPriceWithOff +'" style="background-image: url(\''+ storageCartFoodItemImage +'\');">' +
                        '<div class="col-100 food-data">' +
                        '<div class="row no-gap">' +
                        '<div class="col-100 cart-food-title">' +
                        '<h3 class="food-title">' + storageCartFoodItemName +
                        '</h3>' +
                        '</div>' +
                        '</div>' +
                        '</div><div class="cart-minus"><img src="img/minus.svg" alt="" /></div>' +
                        '<div class="cart-item-counter">'+ storageCartFoodItemCount +'</div></div>';
                }
            }
        });

        if (cartHtml !== '') {

            cartContainer.empty();

            cartContainer.append(cartHtml);

            cartItemHeightHandle();
        }
    } else {

        window.localStorage.setItem("appetizer", '[]');

        let appetizerStorage = JSON.parse(window.localStorage.getItem("appetizer"));

        renderAppetizerList(appetizerStorage, foodMenu);

        cartContainer.empty();

        cartContainer.append('<img class="empty-cart" src="img/empty-cart.svg" />');

        $$('img.empty-cart').show();

    }

    calculateSideCartPrice();

    let appetizerMenu = await cart.getAppetizerMenu(cartList);

    if(appetizerMenu['code'] == 100) {
        renderAppetizersInMenu(appetizerMenu['appetizers']);
    }

    TraceNodes(document);
}

async function renderAppetizerList(appetizerToShow, foodMenu) {

    let appetizerContainer = $$('#appetizer-container');

    if(foodMenu == '' || foodMenu == null || foodMenu == undefined || foodMenu == []) {
        appetizerToShow = [];

        appetizerContainer.empty();
    } else {

        if (appetizerToShow != '' && appetizerToShow != null && appetizerToShow != undefined && appetizerToShow != []) {

            let appetizerHtml = '';

            Object.keys(appetizerToShow).forEach(function(k) {

                if(appetizerToShow[k] != null) {

                    let storageAppetizerItem = appetizerToShow[k];

                    var storageAppetizerItemName = (storageAppetizerItem['name'] !== undefined && storageAppetizerItem['name'] !== '') ? storageAppetizerItem['name'] : 'بدون عنوان';
                    var storageAppetizerItemPrice = (storageAppetizerItem['price'] !== undefined && storageAppetizerItem['price'] !== '') ? storageAppetizerItem['price'] : '';
                    var storageAppetizerItemCount = (storageAppetizerItem['count'] !== undefined && storageAppetizerItem['count'] !== '' && storageAppetizerItem['count'] !== null) ? storageAppetizerItem['count'] : '1';
                    var storageAppetizerItemId = (storageAppetizerItem['id'] !== undefined && storageAppetizerItem['id'] !== '' && storageAppetizerItem['id'] !== null) ? storageAppetizerItem['id'] : '';
                    var storageAppetizerItemImage = (storageAppetizerItem['image'] !== undefined && storageAppetizerItem['image'] !== '') ? storageAppetizerItem['image'] : 'img/food-item.png';

                    appetizerHtml += '<div class="col-100 appetizer-item cart-item animated bounceIn" data-count="'+ storageAppetizerItemCount +'"' +
                        'data-name="'+ storageAppetizerItemName +'" data-price="'+ storageAppetizerItemPrice +'" data-id="'+ storageAppetizerItemId +'" ' +
                        'style="background-image: url('+ storageAppetizerItemImage +');">' +
                        '<div class="col-100 food-data">' +
                        '<div class="row no-gap">' +
                        '<div class="col-100 cart-food-title">' +
                        '<h3 class="food-title">' + storageAppetizerItemName +
                        '</h3>' +
                        '</div>' +
                        '</div>' +
                        '</div><div class="cart-minus"><img src="img/minus.svg" alt="" /></div>' +
                        '<div class="cart-item-counter">'+ storageAppetizerItemCount +'</div></div>';

                }

            });

            if (appetizerHtml !== '') {

                appetizerContainer.empty();

                appetizerContainer.append(appetizerHtml);

                cartItemHeightHandle();
            }
        } else {
            appetizerContainer.empty();
        }

    }

    calculateSideCartPrice();

    TraceNodes(document);
}

function addFoodToCart(foodMenu, cart) {
    $$('.foods-section .food-item').on('click', async function(){

        let storageCart = JSON.parse(window.localStorage.getItem("cart"));

        if( storageCart === null ) {

            storageCart = [];

        }

        let foodName = $$(this).attr('data-title');
        let foodImage = $$(this).attr('data-image');
        let foodId = $$(this).attr('data-id');
        let foodPrice = $$(this).attr('data-price');
        let foodPriceWithOff = $$(this).attr('data-price-with-off');
        let foodContent = $$(this).attr('data-content');
        let foodCount = $$(this).attr('data-count');
        let foodLimitPerInvoice = $$(this).attr('data-limit-per-invoice');
        let foodStock = $$(this).attr('data-stock');
        let foodRestId = $$(this).attr('data-restid');

        let foodItem = new Food(foodId, foodLimitPerInvoice, foodStock, foodName, foodPrice, foodPriceWithOff, foodImage, foodContent, foodCount, foodRestId);

        if (storageCart == [] || storageCart == '' || storageCart == null) {

            if(parseInt(foodStock) > 0) {

                storageCart.push(foodItem);

            } else {

                itemStockError.open();

            }

        } else {

            if(parseInt(foodStock) > 0) {

                var c = 0;

                Object.keys(storageCart).forEach(function(key) {

                    if(storageCart[key] != null) {

                        var sid = storageCart[key].id;
                        var cn = storageCart[key].count;

                        if(parseInt(foodItem.id) === parseInt(sid)) {

                            if(parseInt(foodStock) >= parseInt(cn) + 1) {

                                storageCart[key].count = parseInt(cn) + 1;

                            } else {

                                itemStockError.open();

                            }

                            c = 1;

                        }

                    }

                });

                if (c == 0) {

                    storageCart.push(foodItem);

                }

            } else {

                itemStockError.open();

            }
        }

        window.localStorage.setItem("cart", JSON.stringify(storageCart));
        let cartToShow = JSON.parse(window.localStorage.getItem("cart"));

        renderCartList(cartToShow, foodMenu, cart);

        let appetizerMenu = await cart.getAppetizerMenu(cartToShow);

        if(appetizerMenu['code'] == 100) {
            renderAppetizersInMenu(appetizerMenu['appetizers']);
        }
    });
}

function addAppetizerToCart(foodMenu) {
    $$(document).on('click', '.foods-section .appetizer-item', async function(){

        if (handleLastSubmit()) return false;

        let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

        if( storageAppetizer === null ) {

            storageAppetizer = [];

        }

        let appetizerName = $$(this).attr('data-title');
        let appetizerImage = $$(this).attr('data-image');
        let appetizerId = $$(this).attr('data-id');
        let appetizerPrice = $$(this).attr('data-price');
        let appetizerContent = $$(this).attr('data-content');
        let appetizerCount = $$(this).attr('data-count');
        let appetizerStock = $$(this).attr('data-stock');
        let appetizerRestId = $$(this).attr('data-restid');

        let appetizerItem = new AppetizerItem(appetizerId, appetizerStock, appetizerName, appetizerPrice, appetizerImage, appetizerContent, appetizerCount, appetizerRestId);

        if (storageAppetizer == [] || storageAppetizer == '' || storageAppetizer == null) {

            if(parseInt(appetizerStock) > 0) {

                storageAppetizer.push(appetizerItem);

            } else {

                itemStockError.open();

            }

        } else {

            if(parseInt(appetizerStock) > 0) {

                var c = 0;

                Object.keys(storageAppetizer).forEach(function(key) {

                    if(storageAppetizer[key] != null) {

                        var sid = storageAppetizer[key].id;
                        var cn = storageAppetizer[key].count;

                        if(parseInt(appetizerId) === parseInt(sid)) {

                            if(parseInt(appetizerStock) >= parseInt(cn) + 1) {

                                storageAppetizer[key].count = parseInt(cn) + 1;

                            } else {

                                itemStockError.open();

                            }

                            c = 1;

                        }

                    }

                });

                if (c == 0) {

                    storageAppetizer.push(appetizerItem);

                }

            } else {

                itemStockError.open();

            }
        }

        window.localStorage.setItem("appetizer", JSON.stringify(storageAppetizer));
        let appetizerToShow = JSON.parse(window.localStorage.getItem("appetizer"));

        renderAppetizerList(appetizerToShow, foodMenu);

        // let appetizerMenu = await cart.getAppetizerMenu(cartToShow);

        // if(appetizerMenu['code'] == 100) {
        //     renderAppetizersInMenu(appetizerMenu['appetizers']);
        // }
    });
}

function renderAppetizersInMenu(appetizerMenu) {

    let appetizersContainer = $$('#appetizrs-container');

    appetizersContainer.empty();

    let appetizersHtml = '';

    if(appetizerMenu.length > 0) {
        var appetSectionTitle = '<div class="col-100"><h2 class="category-title">پیش‌غذا و نوشیدنی</h2></div>';
    } else {
        var appetSectionTitle = '';
    }

    Object.keys(appetizerMenu).forEach(function(key) {

        var appetItem = appetizerMenu[key];

        var appetName = (appetItem['title'] !== undefined && appetItem['title'] !== '') ? appetItem['title'] : 'بدون عنوان';
        var appetId = (appetItem['id'] !== undefined && appetItem['id'] !== '') ? appetItem['id'] : '';
        var appetImage = (appetItem['picture'] !== undefined && appetItem['picture'] !== '') ? baseUrl +'/'+ appetItem['picture'] : 'img/food-item.png';
        var appetContent = (appetItem['description'] !== undefined && appetItem['description'] !== '') ? appetItem['description'] : '-';
        var appetStock = (appetItem['stock'] !== undefined && appetItem['stock'] !== '') ? appetItem['stock'] : '50';
        var appetPrice = (appetItem['price'] !== undefined && appetItem['price'] !== '') ? appetItem['price'] : '-';
        var appetRestId = (appetItem['restaurantId'] !== undefined && appetItem['restaurantId'] !== '') ? appetItem['restaurantId'] : '';

        if(appetStock > 0) {
            appetizersHtml += '<div class="col-100 desktop-50 appetizer-item" data-count="1" data-stock="'+ appetStock +'" ' +
                'data-title="'+ appetName +'" data-image="'+ appetImage +'" ' +
                'data-id="'+ appetId +'" data-price="'+ appetPrice +'" data-content="'+ appetContent +'" ' +
                'data-restId="'+ appetRestId +'" style="background-image: url('+ appetImage +');">' +
                '<div class="col-100 food-data"><div class="row no-gap"><div class="col-50 p-10">' +
                '<h3 class="food-title">' + appetName + '</h3>' +
                '<p class="food-detail">'+ appetContent +'</p></div><div class="col-50 p-10 text-left p-relative">' +
                '<span class="price">' + appetPrice + ' تومان</span>' +
                '<a href="" class="add-to-cart"><img src="img/food-plus-icon.svg" alt="" /></a></div></div></div></div>';
        }
    });

    appetizersContainer.append(appetSectionTitle, appetizersHtml);

    TraceNodes(document);

}

function removeFoodFromCart(foodMenu, cart) {
    $(document).on('click', '.cart-minus', function(){

        let storageCart = JSON.parse(window.localStorage.getItem("cart"));

        let foodId = $$(this).parent('.food-item').attr('data-id');

        let foodCount = $$(this).parent('.food-item').attr('data-count');

        Object.keys(storageCart).forEach(function(key) {
            if(storageCart[key] != null) {
                if(foodId == storageCart[key].id) {

                    storageCart[key].count = parseInt(foodCount) - 1;

                    if (storageCart[key].count < 1) {
                        delete storageCart[key];
                    }
                }
            }
        });

        var filteredCart = storageCart.filter(function () {
            return true;
        });

        window.localStorage.setItem("cart", JSON.stringify(filteredCart));

        let cartToShow = JSON.parse(window.localStorage.getItem("cart"));

        renderCartList(cartToShow, foodMenu, cart);
    });
}

function removeAppetizerFromCart(foodMenu, cart) {
    $(document).on('click', '.cart-minus', function(){

        let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

        let appetizerId = $$(this).parent('.appetizer-item').attr('data-id');

        let appetizerCount = $$(this).parent('.appetizer-item').attr('data-count');

        Object.keys(storageAppetizer).forEach(function(key) {
            if(storageAppetizer[key] != null) {
                if(appetizerId == storageAppetizer[key].id) {

                    storageAppetizer[key].count = parseInt(appetizerCount) - 1;

                    if (storageAppetizer[key].count < 1) {
                        delete storageAppetizer[key];
                    }
                }
            }
        });

        var filteredAppetizer = storageAppetizer.filter(function () {
            return true;
        });

        window.localStorage.setItem("appetizer", JSON.stringify(filteredAppetizer));

        let appetizerToShow = JSON.parse(window.localStorage.getItem("appetizer"));

        renderAppetizerList(appetizerToShow, foodMenu);
    });
}

function renderCartPageItems(cart, foodMenu, storageAppetizer) {

    if(cart == '' || cart == null || cart == undefined || cart == []) {
        cart = [];
    }

    if(storageAppetizer == '' || storageAppetizer == null || storageAppetizer == undefined || storageAppetizer == []) {
        storageAppetizer = [];
    }

    let cartHtml = '';
    let appetizerHtml = '';

    let cartPageItemsContainer = $$('#cart-page-items');

    if (cart != '' && cart != null && cart != undefined && cart != []) {

        Object.keys(cart).forEach(function(key) {

            if(cart[key] != null){
                let cartFoodItem = cart[key];

                var foodName = (cartFoodItem['name'] !== undefined && cartFoodItem['name'] !== '') ? cartFoodItem['name'] : 'بدون عنوان';
                var foodPrice = (cartFoodItem['price'] !== undefined && cartFoodItem['price'] !== '') ? cartFoodItem['price'] : '';
                var foodPriceWithOff = (cartFoodItem['priceWithOff'] !== undefined && cartFoodItem['priceWithOff'] !== '') ? cartFoodItem['priceWithOff'] : '';
                var foodCount = (cartFoodItem['count'] !== undefined && cartFoodItem['count'] !== '') ? cartFoodItem['count'] : '1';
                var foodContent = (cartFoodItem['content'] !== undefined && cartFoodItem['content'] !== '') ? cartFoodItem['content'] : '';
                var foodStock = (cartFoodItem['stock'] !== undefined && cartFoodItem['stock'] !== '') ? cartFoodItem['stock'] : '1';
                var foodId = cartFoodItem['id'];

                if (parseInt(foodPrice) === parseInt(foodPriceWithOff)) {
                    var off = '';
                    var finalPrice = foodPrice;
                    var offBox = '';
                } else {
                    var off = 'foodWithOff';
                    var finalPrice = foodPriceWithOff;
                    var offBox = '<div class="cartOffBox"><del>'+ foodPrice.toString().formatPrice() +' تومان </del></div>';
                }

                var flag = 0;
                Object.keys(foodMenu).forEach(function(j) {
                    if(foodMenu[j] != null) {
                        let foodMenuFoodItem = foodMenu[j][0];
                        var foodMenuFoodItemId = foodMenuFoodItem['id'];

                        if( flag == 0) {
                            if (parseInt(foodId) === parseInt(foodMenuFoodItemId)) {

                                cartHtml += '<div class="col-100 desktop-50 p-relative cart-food-item '+ off +'">' +
                                    '                            <div class="row">' +
                                    '                                <div class="col-66">' +
                                    '                                    <h2>' +
                                    foodName +
                                    '                                    </h2>' +
                                    '                                    <p>'+ foodContent +'</p>' +
                                    '                                </div>' +
                                    '                                <div class="col-33" style="margin-top: 5px">' +
                                    '                                    <div class="col-100 text-left" data-stock="'+ foodStock +'">' +
                                    '                                        <a class="increase-item">' +
                                    '                                            <img src="img/plus-cart.svg" />' +
                                    '                                        </a>' +
                                    '                                        <span class="cart-food-count" item-id="'+ foodId +'" count-item="'+ foodCount +'">' +
                                    foodCount +
                                    '                                        </span>' +
                                    '                                        <a class="decrease-item">' +
                                    '                                            <img src="img/minus-cart.svg" />' +
                                    '                                        </a>' +
                                    '                                    </div>' +
                                    '                                    <div class="col-100 text-left cart-food-price">' +
                                    finalPrice.toString().formatPrice() + ' تومان' +
                                    '</div>' +
                                    '                                </div>' +
                                    offBox +
                                    '                            </div>' +
                                    '                        </div>';

                                flag = 1;
                            }
                        }
                    }
                });
                if(flag == 0) {
                    cartHtml += '<div class="col-100 desktop-50 p-relative cart-page-no-stock cart-food-item '+ off +'">' +
                        '                            <div class="row">' +
                        '                                <div class="col-66">' +
                        '                                    <h2>' +
                        foodName +
                        '                                    </h2>' +
                        '                                    <p>' +
                        '                                        یک کیلو آش، با نعناع داغ و کشک' +
                        '                                    </p>' +
                        '                                </div>' +
                        '                                <div class="col-33">' +
                        '                                    <div class="col-100 text-left" data-stock="'+ foodStock +'">' +
                        '                                        <a class="increase-item n-stock">' +
                        '                                            <img src="img/plus-cart.svg" />' +
                        '                                        </a>' +
                        '                                        <span class="cart-food-count" item-id="'+ foodId +'" count-item="'+ foodCount +'">' +
                        foodCount +
                        '                                        </span>' +
                        '                                        <a class="decrease-item n-stock">' +
                        '                                            <img src="img/minus-cart.svg" />' +
                        '                                        </a>' +
                        '                                    </div>' +
                        '                                    <div class="col-100 text-left cart-food-price">' +
                        finalPrice + ' تومان' +
                        '</div>' +
                        '                                </div>' +
                        offBox +
                        '                            </div>' +
                        '                        </div>';
                }
            }

        });

        if(storageAppetizer != '' && storageAppetizer != null && storageAppetizer != undefined && storageAppetizer != []) {
            Object.keys(storageAppetizer).forEach(function(key) {

                if(storageAppetizer[key] != null){
                    let cartFoodItem = storageAppetizer[key];

                    var foodName = (cartFoodItem['name'] !== undefined && cartFoodItem['name'] !== '') ? cartFoodItem['name'] : 'بدون عنوان';
                    var foodPrice = (cartFoodItem['price'] !== undefined && cartFoodItem['price'] !== '') ? cartFoodItem['price'] : '';
                    var foodContent = (cartFoodItem['content'] !== undefined && cartFoodItem['content'] !== '') ? cartFoodItem['content'] : '';
                    var foodCount = (cartFoodItem['count'] !== undefined && cartFoodItem['count'] !== '') ? cartFoodItem['count'] : '1';
                    var foodStock = (cartFoodItem['stock'] !== undefined && cartFoodItem['stock'] !== '') ? cartFoodItem['stock'] : '1';
                    var foodId = cartFoodItem['id'];

                    appetizerHtml += '<div class="col-100 desktop-50 p-relative cart-food-item">' +
                        '                            <div class="row">' +
                        '                                <div class="col-66">' +
                        '                                    <h2>' +
                        foodName +
                        '                                    </h2>' +
                        '                                    <p>'+ foodContent +'</p>' +
                        '                                </div>' +
                        '                                <div class="col-33">' +
                        '                                    <div class="col-100 text-left" data-stock="'+ foodStock +'">' +
                        '                                        <a class="increase-item">' +
                        '                                            <img src="img/plus-cart.svg" />' +
                        '                                        </a>' +
                        '                                        <span class="cart-food-count" item-id="'+ foodId +'" count-item="'+ foodCount +'">' +
                        foodCount +
                        '                                        </span>' +
                        '                                        <a class="decrease-item">' +
                        '                                            <img src="img/minus-cart.svg" />' +
                        '                                        </a>' +
                        '                                    </div>' +
                        '                                    <div class="col-100 text-left cart-food-price">' +
                        foodPrice + ' تومان' +
                        '</div>' +
                        '                                </div>' +
                        '                            </div>' +
                        '                        </div>';

                }

            });
        }

        cartPageItemsContainer.empty();

        cartPageItemsContainer.append(cartHtml + appetizerHtml);


    } else {
        cartPageItemsContainer.empty();

        cartPageItemsContainer.append('سبد خرید شما خالی است');
    }

    TraceNodes(document);
}

function increaseFoodCartPage(cart, foodMenu, storageAppetizer) {
    $$(document).on('click', '.increase-item', function() {

        if (handleLastSubmit()) return false;

        var countInt = parseInt($$(this).next('.cart-food-count').attr('count-item')) + 1;
        var stockCount = parseInt($$(this).parent().attr('data-stock'));

        var itemId = $$(this).next('.cart-food-count').attr('item-id');

        if ($$(this).hasClass('n-stock')) {

            app.dialog.confirm('این آیتم موجود نیست، میخوای حذفش کنی؟', function () {
                Object.keys(cart).forEach(function(key) {
                    if(cart[key]!= null) {
                        if (cart[key].id === itemId) {
                            cart.splice(key, 1);
                        }
                    }
                });

                Object.keys(storageAppetizer).forEach(function(key) {
                    if(storageAppetizer[key]!= null) {
                        if (storageAppetizer[key].id === itemId) {
                            storageAppetizer.splice(key, 1);
                        }
                    }
                });

                window.localStorage.setItem("cart", JSON.stringify(cart));
                window.localStorage.setItem("appetizer", JSON.stringify(storageAppetizer));

                var updatedCart = JSON.parse(window.localStorage.getItem("cart"));
                var updatedAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

                renderCartPageItems(updatedCart, foodMenu, updatedAppetizer);

                calculatePrices(updatedCart, updatedAppetizer);

                // refreshApp();

            });

        } else {
            if(countInt <= stockCount) {
                Object.keys(cart).forEach(function(key) {
                    if(cart[key] != null) {
                        if (cart[key].id === itemId) {
                            cart[key].count = parseInt(cart[key].count) + 1;
                        }
                    }
                });

                Object.keys(storageAppetizer).forEach(function(key) {
                    if(storageAppetizer[key] != null) {
                        if (storageAppetizer[key].id === itemId) {
                            storageAppetizer[key].count = parseInt(storageAppetizer[key].count) + 1;
                        }
                    }
                });

                window.localStorage.setItem("cart", JSON.stringify(cart));
                window.localStorage.setItem("appetizer", JSON.stringify(storageAppetizer));
                var updatedCart = JSON.parse(window.localStorage.getItem("cart"));
                var updatedAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

                // calculatePrices(updatedCart, storageAppetizer);

                $$(this).next('.cart-food-count').empty();

                $$(this).next('.cart-food-count').append(''+ countInt +'');
                $$(this).next('.cart-food-count').attr('count-item', countInt );
                calculatePrices(updatedCart, updatedAppetizer);

            } else {
                itemStockError.open();
            }
        }

        TraceNodes(document);
    });
}

function decreaseFoodCartPage(cart, foodMenu, storageAppetizer) {
    $$(document).on('click', '.decrease-item', function() {

        if (handleLastSubmit()) return false;

        var countInt = parseInt($$(this).prev('.cart-food-count').attr('count-item')) - 1;
        var itemId = $$(this).prev('.cart-food-count').attr('item-id');

        if ($$(this).hasClass('n-stock')) {
            app.dialog.confirm('این آیتم موجود نیست، میخوای حذفش کنی؟', function () {

                Object.keys(cart).forEach(function(key) {
                    if(cart[key]!= null) {
                        if (cart[key].id === itemId) {
                            cart.splice(key, 1);
                        }
                    }
                });

                Object.keys(storageAppetizer).forEach(function(key) {
                    if(storageAppetizer[key]!= null) {
                        if (storageAppetizer[key].id === itemId) {
                            storageAppetizer.splice(key, 1);
                        }
                    }
                });

                window.localStorage.setItem("cart", JSON.stringify(cart));
                window.localStorage.setItem("appetizer", JSON.stringify(storageAppetizer));

                updatedCart = updatedCart.filter(function (el) {
                    return el != null;
                });

                updatedAppetizer = updatedAppetizer.filter(function (el) {
                    return el != null;
                });

                if(updatedCart.length > 0) {
                    renderCartPageItems(updatedCart, foodMenu, updatedAppetizer);
                } else {
                    refreshApp();
                }

                calculatePrices(updatedCart, updatedAppetizer);

            });
        } else {
            if(countInt > 0) {
                Object.keys(cart).forEach(function(key) {
                    if(cart[key] != null) {
                        if (cart[key].id === itemId) {
                            cart[key].count = parseInt(cart[key].count) - 1;
                        }
                    }
                });

                Object.keys(storageAppetizer).forEach(function(key) {
                    if(storageAppetizer[key] != null) {
                        if (storageAppetizer[key].id === itemId) {
                            storageAppetizer[key].count = parseInt(storageAppetizer[key].count) - 1;
                        }
                    }
                });

                window.localStorage.setItem("cart", JSON.stringify(cart));
                window.localStorage.setItem("appetizer", JSON.stringify(storageAppetizer));
                var updatedCart = JSON.parse(window.localStorage.getItem("cart"));
                var updatedAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

                calculatePrices(updatedCart, updatedAppetizer);

                $$(this).prev('.cart-food-count').empty();

                $$(this).prev('.cart-food-count').append(''+ countInt +'');
                $$(this).prev('.cart-food-count').attr('count-item', countInt );
            } else {
                app.dialog.confirm('میخوای این غذا رو حذف کنی؟', function () {

                    Object.keys(cart).forEach(function(key) {
                        if(cart[key]!= null) {
                            if (cart[key].id === itemId) {
                                cart.splice(key, 1);
                            }
                        }
                    });

                    Object.keys(storageAppetizer).forEach(function(key) {
                        if(storageAppetizer[key]!= null) {
                            if (storageAppetizer[key].id === itemId) {
                                storageAppetizer.splice(key, 1);
                            }
                        }
                    });

                    window.localStorage.setItem("cart", JSON.stringify(cart));
                    window.localStorage.setItem("appetizer", JSON.stringify(storageAppetizer));
                    var updatedCart = JSON.parse(window.localStorage.getItem("cart"));
                    var updatedAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

                    updatedCart = updatedCart.filter(function (el) {
                        return el != null;
                    });

                    updatedAppetizer = updatedAppetizer.filter(function (el) {
                        return el != null;
                    });

                    calculatePrices(updatedCart, updatedAppetizer);

                    if(updatedCart.length > 0) {
                        renderCartPageItems(updatedCart, foodMenu, updatedAppetizer);
                    } else {
                        refreshApp();
                    }

                });
            }
        }

        TraceNodes(document);
    });
}

function renderAddresses(addresses, availableAddresses=false ,initFromHomePage=false) {

    let selectedAddress = window.localStorage.getItem("selectedAddress");

    if(addresses === null) {
        addresses = []
    }

    // console.log(addresses)

    $$('.no-address-new-address').hide();

    let addressItems = '';

    let flag = 0;
    if(initFromHomePage != false) {
        Object.keys(addresses).forEach(function(key) {

            let item = addresses[key];
            let id = key;

            let address = item['address'];
            let title = item['title'];
            let phone = item['phone'];

                addressItems += '<div class="col-100 desktop-50 address-item address-menu-address-selector" item-id="'+ id +'">' +
                    '                            <div class="row top-address-item">' +
                    '                                <div class="col-66">' +
                    '                                    <h2>'+ title +'</h2>' +
                    '                                </div>' +
                    '                                <div class="col-33">' +
                    '                                    <div class="col-100 text-left phone">' +
                    phone +
                    '                                    </div>' +
                    '                                </div>' +
                    '                            </div>' +
                    '                            <div class="row">' +
                    '                                <div class="col-90">' +
                    '                                    <p>'+ address +'</p>' +
                    '                                </div>' +
                    '                                <div class="col-10 address-icons">' +
                    // '<i class="f7-icons address-edit-btn">edit</i>' +
                    '<i class="f7-icons address-remove-btn">trash</i>حذف</div>' +
                    '                            </div>' +
                    '</div>';
        });
    } else {
        Object.keys(addresses).forEach(function(key) {

            let item = addresses[key];
            let id = key;

            let address = item['address'];
            let title = item['title'];
            let phone = item['phone'];

            let counter = 0;
            let selectedClass= '';

            if(availableAddresses != false) {
                Object.keys(availableAddresses).forEach(function(j) {
                    let avAddressItem = availableAddresses[j];

                    if(counter == 0) {
                        if(avAddressItem.address == id) {
                            if(selectedAddress != undefined && selectedAddress != '' && selectedAddress != null && selectedAddress == avAddressItem.address && selectedAddress != 'no' ) {
                                selectedClass = 'active-address';
                            }
                            addressItems += '<div class="col-100 desktop-50 address-item '+ selectedClass +'" item-id="'+ id +'" shippment-price="'+ avAddressItem.delivery +'">' +
                                '                            <div class="row top-address-item">' +
                                '                                <div class="col-66">' +
                                '                                    <h2>'+ title +'</h2>' +
                                '                                </div>' +
                                '                                <div class="col-33">' +
                                '                                    <div class="col-100 text-left phone">' +
                                phone +
                                '                                    </div>' +
                                '                                </div>' +
                                '                            </div>' +
                                '                            <div class="row">' +
                                '                                <div class="col-90">' +
                                '                                    <p>'+ address +'</p>' +
                                '                                </div>' +
                                '                                <div class="col-10 address-icons">' +
                                // '<i class="f7-icons address-edit-btn">edit</i>' +
                                '<i class="f7-icons address-remove-btn">trash</i></div>' +
                                '                            </div>' +
                                '                        </div>';
                            counter = 1;
                        }
                    }
                });
                if(counter == 0) {
                    addressItems += '<div class="col-100 desktop-50 address-item deactiveAddress" item-id="'+ id +'">' +
                        '                            <div class="row top-address-item">' +
                        '                                <div class="col-66">' +
                        '                                    <h2>'+ title +'</h2>' +
                        '                                </div>' +
                        '                                <div class="col-33">' +
                        '                                    <div class="col-100 text-left phone">' +
                        phone +
                        '                                    </div>' +
                        '                                </div>' +
                        '                            </div>' +
                        '                            <div class="row">' +
                        '                                <div class="col-90">' +
                        '                                    <p>'+ address +'</p>' +
                        '                                </div>' +
                        '                                <div class="col-10 address-icons">' +
                        // '<i class="f7-icons address-edit-btn">edit</i>' +
                        '<i class="f7-icons address-remove-btn">trash</i></div>' +
                        '                            </div>' +
                        '                        </div>';
                    counter = 1;
                }
            } else {
                addressItems += '<div class="col-100 desktop-50 address-item" item-id="'+ id +'">' +
                    '                            <div class="row top-address-item">' +
                    '                                <div class="col-66">' +
                    '                                    <h2>'+ title +'</h2>' +
                    '                                </div>' +
                    '                                <div class="col-33">' +
                    '                                    <div class="col-100 text-left phone">' +
                    phone +
                    '                                    </div>' +
                    '                                </div>' +
                    '                            </div>' +
                    '                            <div class="row">' +
                    '                                <div class="col-90">' +
                    '                                    <p>'+ address +'</p>' +
                    '                                </div>' +
                    '                                <div class="col-10 address-icons">' +
                    '<i class="f7-icons address-remove-btn">trash</i></div>' +
                    '                            </div>' +
                    '                        </div>';
            }

        });
    }

    let addAddressHtml = '';
    if(addressItems != '' && addressItems != undefined && addressItems!= null) {
        $$('.no-address-new-address').hide();
        $$('.no-address').html('');


        addAddressHtml = '<div class="col-100 desktop-50 add-address-in-list add-address-btnn">' +
            '<div class="row"><div class="col-100 add-address-items">' +
            '<div class="add-address-plus"><img src="img/food-plus-icon.svg" alt="" /></div>' +
            '<div class="add-address-title">آدرس جدید</div>' +
            '</div></div><div class="row"></div></div>';


    } else {
        $$('.no-address-new-address').show();
        $$('.no-address').html('<p class="no-address">شما هنوز آدرسی ثبت نکرده‌اید</p>');
    }

    $$('.addresses').empty();
    $$('.addresses').append(addressItems + addAddressHtml);

}

function convertToEnglish(str) {
    var persianNumbers = [/۰/g, /۱/g, /۲/g, /۳/g, /۴/g, /۵/g, /۶/g, /۷/g, /۸/g, /۹/g];
    var arabicNumbers  = [/٠/g, /١/g, /٢/g, /٣/g, /٤/g, /٥/g, /٦/g, /٧/g, /٨/g, /٩/g];
    if(typeof str === 'string')
    {
        for(var i=0; i<10; i++)
        {
            str = str.replace(persianNumbers[i], i).replace(arabicNumbers[i], i);
        }
    }
    return str;
};

function renderSidebarData() {

    $$('.mobile-sidebar').html(mobileSidebar);
    if(user.mobile != false && user.mobile != '' && user.mobile != undefined && user.mobile != null) {
        $$('.side-phone').html(user.mobile);
    }


    // Open dynamic popover
    $$('.profile-popover').on('click', function () {

        dynamicPopover.open();

        $$('input.firstName').val(''+ user.firstName +'');
        $$('input.lastName').val(''+ user.lastName +'');

        $$('.profile-save').on('click', function () {
            $$(this).css('pointer-events', 'none');
            $$(this).html('صبر کنید');

            var firstName = $$('input.firstName').val();
            var lastName = $$('input.lastName').val();

            user.editProfile(firstName, lastName);
        });

    });

    $$('.wallet-sidebar').empty();
    $$('.wallet-sidebar').append(''+ user.wallet.toString().formatPrice() +' تومان');

    $$('.user-name-top').empty();

    if(user.name !== null) {
        $$('.user-name-top').append(''+ user.name +'');
    } else {
        $$('.user-name-top').append(''+ user.mobile +'');
    }

    $$(document).on('click', '.go-to-invoices-page', function() {
        goToInvoicesPage();
    });

    $$(document).on('click','.go-to-terms-page', function(){
        goToTermsPage()
    });

    $$(document).on('click','.go-to-about-page', function(){
        goToAboutPage()
    });

    $$(document).on('click','.go-to-privacy-page', function(){
        goToPrivacyPage()
    });

    $$(document).on('click','.goToEditProfile', function(){
        goToEditProfile()
    });
}

function goToTermsPage() {
    if (mainView !== null) {
        mainView.router.navigate('/terms/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    termsPageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/terms/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    termsPageInit()
                }
            }
        });
    }
}

function goToAboutPage() {
    if (mainView !== null) {
        mainView.router.navigate('/about/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    aboutPageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/about/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    aboutPageInit()
                }
            }
        });
    }
}

function goToPrivacyPage() {
    if (mainView !== null) {
        mainView.router.navigate('/privacy/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    privacyPageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/privacy/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    privacyPageInit()
                }
            }
        });
    }
}

function goToEditProfile() {
    if (mainView !== null) {
        mainView.router.navigate('/profile/', {
            pushState: true,
            on: {
                pageInit: function (page) {
                    profilePageInit()
                }
            }
        });
    } else {
        mainView = app.views.create('.view-main', {
            url: '/profile/',
            pushState: true,
            on: {
                pageInit: function (page) {
                    profilePageInit()
                }
            }
        });
    }
}

function preparingMobileAndSend() {
    let mobileEn = convertToEnglish($$('.mobile-input').val());
    let mobile = mobileEn.replace(/^0+/, '');

    if(mobile.length > 9) {
        $$('.btn-login').html('لطفا صبر کنید');
        $$('.btn-login').css('pointer-events', 'none');

        user.login(mobile, function (response) {
            if(response['code'] === 100) {
                goToConfirmPage(mobile);
            } else {
                $$('.btn-login').css('pointer-events', 'all');
                $$('.btn-login').html('ورود');

                mobileError.open();
            }
        });
    } else {
        mobileError.open();
    }
}

function calculatePrices(cart, storageAppetizer, availableAddresses=false) {

    // if(availableAddresses != false) {
    //     shippmentPrice = availableAddresses;
    // }

    $$('.bill-item-main-price b').empty();
    $$('.price-main b').empty();

    var price = 0;
    var priceBeforeOff = 0;
    Object.keys(cart).forEach(function(key) {

        if(cart[key]!= null) {
            var count = cart[key].count;
            var mainPrice = cart[key].price;
            var mainPriceWithOff = cart[key].priceWithOff;

            priceBeforeOff = priceBeforeOff + parseInt(mainPrice * count);

            if (mainPrice === mainPriceWithOff) {
                price = price + parseInt(mainPrice * count);
            } else {
                price = price + parseInt(mainPriceWithOff * count);
            }
        }

    });


    var appetPrice = 0;
    if (storageAppetizer !== undefined) {
        Object.keys(storageAppetizer).forEach(function (key) {

            if (storageAppetizer[key] != null && storageAppetizer != []) {
                var count = storageAppetizer[key].count;
                var mainPrice = storageAppetizer[key].price;

                appetPrice = appetPrice + parseInt(mainPrice * count);
            }

        });
    }

    var mainPriceWithShippment = parseInt(price) + parseInt(shippmentPrice) + parseInt(appetPrice) + parseInt(packagingPrice);

    $$('.bill-item-main-price b').append(''+ mainPriceWithShippment.toString().formatPrice() +' تومان');

    var priceBeforeOffFinal = priceBeforeOff + appetPrice;

    $$('.price-main b').append(''+ priceBeforeOffFinal.toString().formatPrice() +' تومان');

    $$('.bill-off b').empty();

    $$('.bill-off b').append(''+ (priceBeforeOff - price).toString().formatPrice() +' تومان');

    $$('.shippmentPrice b').empty();
    $$('.shippmentPrice b').append(shippmentPrice.toString().formatPrice() + ' تومان ');

    $$('.packagingPrice b').empty();
    $$('.packagingPrice b').append(packagingPrice.toString().formatPrice() + ' تومان ');

    TraceNodes(document);
}

function calculatePricesWithOffCode(coupon, cart, storageAppetizer) {

    let off = parseInt((coupon.amount.toString()).replace('%', ''));;
    let ceil = parseInt(coupon.ceil);

    if( off > 100 ) {
        // toman

        $$('.bill-item-main-price b').empty();
        $$('.price-main b').empty();

        var price = 0;
        var priceBeforeOff = 0;
        Object.keys(cart).forEach(function(key) {

            if(cart[key]!= null) {
                var count = cart[key].count;
                var mainPrice = cart[key].price;
                var mainPriceWithOff = cart[key].priceWithOff;

                priceBeforeOff = priceBeforeOff + parseInt(mainPrice * count);

                if (mainPrice === mainPriceWithOff) {
                    price = price + parseInt(mainPrice * count);
                } else {
                    price = price + parseInt(mainPriceWithOff * count);
                }
            }

        });

        var appetPrice = 0;
        if (storageAppetizer !== undefined) {
            Object.keys(storageAppetizer).forEach(function (key) {

                if (storageAppetizer[key] != null && storageAppetizer != []) {
                    var count = storageAppetizer[key].count;
                    var mainPrice = storageAppetizer[key].price;

                    appetPrice = appetPrice + parseInt(mainPrice * count);
                }

            });
        }

        var mainPriceWithShippment = parseInt(price) + parseInt(shippmentPrice) + parseInt(appetPrice) + parseInt(packagingPrice);

        $$('.bill-item-main-price b').append(''+ (mainPriceWithShippment - off).toString().formatPrice() +' تومان');

        var priceBeforeOffFinal = priceBeforeOff + appetPrice;

        $$('.price-main b').append(''+ priceBeforeOffFinal.toString().formatPrice() +' تومان');

        $$('.bill-off b').empty();

        $$('.bill-off b').append(''+ ((priceBeforeOff - price) + off).toString().formatPrice() +' تومان');

        $$('.shippmentPrice b').empty();
        $$('.shippmentPrice b').append(shippmentPrice.toString().formatPrice() + ' تومان ');

        $$('.packagingPrice b').empty();
        $$('.packagingPrice b').append(packagingPrice.toString().formatPrice() + ' تومان ');
    } else {
        // percent

        $$('.bill-item-main-price b').empty();
        $$('.price-main b').empty();

        var price = 0;
        var priceBeforeOff = 0;
        Object.keys(cart).forEach(function(key) {

            if(cart[key]!= null) {
                var count = cart[key].count;
                var mainPrice = cart[key].price;
                var mainPriceWithOff = cart[key].priceWithOff;

                priceBeforeOff = priceBeforeOff + parseInt(mainPrice * count);

                if (mainPrice === mainPriceWithOff) {
                    price = price + parseInt(mainPrice * count);
                } else {
                    price = price + parseInt(mainPriceWithOff * count);
                }
            }

        });

        var appetPrice = 0;
        if (storageAppetizer !== undefined) {
            Object.keys(storageAppetizer).forEach(function (key) {

                if (storageAppetizer[key] != null && storageAppetizer != []) {
                    var count = storageAppetizer[key].count;
                    var mainPrice = storageAppetizer[key].price;

                    appetPrice = appetPrice + parseInt(mainPrice * count);
                }

            });
        }

        var mainPriceWithShippment = parseInt(price) + parseInt(shippmentPrice) + parseInt(appetPrice) + parseInt(packagingPrice);

        off = (mainPriceWithShippment * off)/100;

        if( off > ceil ) {
            off = ceil;
        };

        $$('.bill-item-main-price b').append(''+ (mainPriceWithShippment - off).toString().formatPrice() +' تومان');

        var priceBeforeOffFinal = priceBeforeOff + appetPrice;

        $$('.price-main b').append(''+ priceBeforeOffFinal.toString().formatPrice() +' تومان');

        $$('.bill-off b').empty();

        $$('.bill-off b').append(''+ ((priceBeforeOff - price) + off).toString().formatPrice() +' تومان');

        $$('.shippmentPrice b').empty();
        $$('.shippmentPrice b').append(shippmentPrice.toString().formatPrice() + ' تومان ');

        $$('.packagingPrice b').empty();
        $$('.packagingPrice b').append(packagingPrice.toString().formatPrice() + ' تومان ');

    }

    TraceNodes(document);
}

function calculateSideCartPrice() {

    let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));
    let storageCart = JSON.parse(window.localStorage.getItem("cart"));

    if(storageCart == null) {
        storageCart = [];
    }

    $$('.cart-price').empty();

    var price = 0;
    Object.keys(storageCart).forEach(function(key) {
        if(storageCart[key] != null) {
            // price = price + parseInt(cart[key].price * cart[key].count);

            var count = storageCart[key].count;
            var mainPrice = storageCart[key].price;
            var mainPriceWithOff = storageCart[key].priceWithOff;

            if (mainPrice === mainPriceWithOff) {
                price = price + parseInt(mainPrice * count);
            } else {
                price = price + parseInt(mainPriceWithOff * count);
            }
        }
    });

    var sum = 0;
    Object.keys(storageAppetizer).forEach(function(key) {
        if(storageAppetizer[key] != null) {
            // price = price + parseInt(cart[key].price * cart[key].count);

            var count = storageAppetizer[key].count;
            var priceAppet = storageAppetizer[key].price;

            sum = sum + parseInt(priceAppet * count);
        }
    });

    var sumPrice = price + sum;

    $$('.cart-price').append(''+ sumPrice.toString().formatPrice() +' تومان');

    TraceNodes(document);
}

function handleReciept() {

    // $$('.shippmentPrice b').empty();
    $$('.shippmentPrice b').html(shippmentPrice.toString().formatPrice() + ' تومان ');

    $$(document).on('click', '.bill-open', function () {

        if (handleLastSubmit()) return false;

        let flag = $$(this).hasClass('close');

        if (flag === true) {
            $$(this).toggleClass("open close");

            $$('.bill-main').attr('style', 'height: 100% !important');
            $$(this).attr('src', 'img/close-down.svg');
        } else {
            $$(this).toggleClass("open close");

            $$('.bill-main').css('height','45px');
            $$(this).attr('src', 'img/open-up.svg');
        }
    });

}

function handleAddressDelete() {
    $$(document).on('click', '.address-remove-btn', function (e) {
        e.preventDefault();
        if (handleLastSubmit()) return false;
        let that = this;
        app.dialog.confirm('می‌خوای این آدرس رو حذف کنی؟', async function () {
            let index = $$(that).parent().parent().parent().attr('item-id');
            // console.log('index:', index);
            let blocker1 = await user.deleteAddress(index.toString());
            if (blocker1) {

                try {
                    let blocker2 = await user.startup(false);

                    let pageName = app.views.main.router.currentRoute.name;
                    if (pageName === 'choose-address') {

                        let availableAddresses = await checkAvailableAddresses();

                        if(availableAddresses.code == 100) {
                            let foodMenu = JSON.parse(window.localStorage.getItem("foodMenu"));
                            dynamicPopup.close();
                            chooseAddressPageInit(null, foodMenu, availableAddresses.availableAddresses);
                        } else {
                            // refreshApp();
                        }

                    } else {
                        renderAddresses(user.userData.user.data['addresses'], false, true);
                        let selectedAddress = window.localStorage.getItem('selectedAddress');
                        if (parseInt(selectedAddress) === parseInt(index)) {
                            window.localStorage.setItem('selectedAddress', 'no');
                        }
                    }

                } catch (e) {
                    refreshApp();
                }

            } else {
                noInternet.open();
            }

        });
        return false;
    })
}

function getParentLang(node) {
    var defaultLang = 'fa';
    var currLang = null;
    while(currLang === null && node.parentNode) {
        if (node.getAttribute && node.getAttribute('lang')) {
            currLang = node.getAttribute('lang');
        }
        node = node.parentNode;
    }
    return currLang || defaultLang;
}

function TraceNodes(e) {
    if (e.nodeType == 3 && getParentLang(e) === 'fa' /* Persian */) {
        e.nodeValue = e.nodeValue.toPersianDigit();
    } else {
        for (var t = 0; t < e.childNodes.length; t++) {
            TraceNodes(e.childNodes[t]);
        }
    }
}

String.prototype.toPersianDigit = function(e) {
    return this.replace(/\d+/g, function(t) {
        var n = [], r = [];
        for (var i = 0; i < t.length; i++) {
            n.push(t.charCodeAt(i))
        }
        for (var s = 0; s < n.length; s++) {
            r.push(String.fromCharCode(n[s] + (!!e && e == true ? 1584 : 1728)))
        }
        return r.join("")
    })
};

function logout() {
    app.dialog.confirm('می‌خوای از اجاق خارج شی ...', function () {
        localStorage.clear();
        refreshApp();
    });
}

function refreshApp() {
    if(platform === 'browser') {
        window.location = homeUrl;
    } else {
        location.reload();
    }
}

function getLocationName(locationData) {
    let locationName = locationData.address_compact;

    if (locationName == "") {
        locationName = locationData.neighbourhood;
    }

    if (locationName == "") {
        locationName = locationData.primary;
    }

    if (locationName == "") {
        locationName = locationData.name;
    }

    if (locationName == "") {
        locationName = locationData.postal_address;
    }

    return (locationName);
}

function getLocationNameForNavbar(locationData) {
    let locationNameForNavbar = locationData.neighbourhood;

    if (locationNameForNavbar == "") {
        locationNameForNavbar = locationData.name;
    }

    if (locationNameForNavbar == "") {
        locationNameForNavbar = locationData.address_compact;
    }

    if (locationNameForNavbar == "") {
        locationNameForNavbar = locationData.primary;
    }

    if (locationNameForNavbar == "") {
        locationNameForNavbar = locationData.postal_address;
    }

    return (locationNameForNavbar);
}

function handleLastSubmit() {
    let timestamp = Math.floor(Date.now() / 1000);
    if (timestamp < (lastSubmitTimestamp+0.5)) {
        return true;
    }
    lastSubmitTimestamp = timestamp;
    return false;
}

async function locationForHomePageInit(user, usingCallback=false, callback=false) {
    let locationName = 'انتخاب محله';
    let lat = "";
    let lng = "";
    let userLocation = await user.loadUserLocation();
    if (userLocation['selectedAddress'] !== 'no' &&
        userLocation['selectedAddress'] !== undefined &&
        userLocation['selectedAddress'] !== null &&
        userLocation['selectedAddress'] !== false &&
        userLocation['selectedAddress'] !== ''
    ) {
        if(user.userData.user.data['addresses'][userLocation['selectedAddress']] != undefined) {
            locationName = user.userData.user.data['addresses'][userLocation['selectedAddress']]['title'];
        }
        lat = userLocation.lat;
        lng = userLocation.lng;

    } else if(userLocation.lat !== undefined && userLocation.lat != null && userLocation.lat !== '' && userLocation.lng !== undefined && userLocation.lng != null && userLocation.lng !== '') {

        lat = userLocation.lat;
        lng = userLocation.lng;

        let locationData = await user.getUserLocationName(lat, lng);
        // locationName = locationData.name;
        // locationName = getLocationName(locationData);
        locationName = getLocationNameForNavbar(locationData);

    }

    // return [lat, lng, locationName];

    if (usingCallback) {
        callback(lat, lng, locationName)
    } else {
        return [lat, lng, locationName];
    }
}

function checkAvailableAddresses() {
    var url = baseUrl +'/api/v1/available-addresses';
    let storageCart = JSON.parse(window.localStorage.getItem("cart"));
    let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

    var data = new FormData();
    data.append("platform", platform);
    data.append("version", appVersion);
    Object.keys(storageCart).forEach(function(key) {
        let cartFoodItem = storageCart[key];

        data.append("foods["+ cartFoodItem['id'] +"]", cartFoodItem['count']);
    });
    if(storageAppetizer != undefined && storageAppetizer != [] && storageAppetizer != '' && storageAppetizer.length > 0) {
        Object.keys(storageAppetizer).forEach(function (key) {
            let appetItem = storageAppetizer[key];

            data.append("appetizers[" + appetItem['id'] + "]", appetItem['count']);
        });
    }

    var settings = {
        async: true,
        crossDomain: crossDomainParam,
        url: url,
        dataType: "json",
        method: "POST",
        headers: {
            "X-AUTH-TOKEN": user['confirmationToken'],
            "X-AUTH-MOBILE": user['mobile']
        },
        processData: false,
        contentType: false,
        mimeType: "multipart/form-data",
        data: data
    };

    return $.ajax(settings).done(function (response) {

        return response;

    }).fail(function(response, status, error) {

        $$('.cart-page-next-btn a').html('انتخاب آدرس');
        $$('.cart-page-next-btn').css('pointer-events', 'all');
        // console.log(response);

        noInternet.open();

    });
}

function orderTimeStatus() {
    let preorderTimes = user.preorderTimes;

    let preorderId = window.localStorage.getItem("preorderId");
    if(preorderId != undefined && preorderId != null && preorderId != '' && preorderTimes != [] && preorderTimes != {} && preorderTimes != '' && preorderTimes != null && preorderTimes != undefined){
        let counter = 0;
        let itemTime = 'پیش‌سفارش';
        Object.keys(preorderTimes).forEach(function(key) {
            let item =  preorderTimes[key];
            if(counter == 0 && item.capacity > 0) {
                if(item.id == preorderId) {
                    itemTime = ''+ item.start +' - ' + item.end + '';
                    counter++;
                }
            }
        });
        $$('.order-time').html(itemTime);
        TraceNodes(document);
    } else {
        window.localStorage.setItem("preorderId", '');
        $$('.order-time').html('پیش‌سفارش');
    }
}

function renderPreorderText() {
    let preorderId = window.localStorage.getItem("preorderId");
    if( preorderId != undefined && preorderId != '' && preorderId != null && preorderId != [] && preorderId != {} ){
        Object.keys(user.preorderTimes).forEach(function(key) {
            var item =  user.preorderTimes[key];
            let preorderStart = item.start;
            let preorderEnd = item.end;
            if(preorderId == item.id){
                $$('.preorder-hint').show();
                $$('.preorder-hint').html('<p class="preorder-text-p">پیش‌سفارش برای ' + preorderStart + ' الی ' + preorderEnd +
                    ' </p>');
            }
        });
    }
}

async function handleCouponCode(codeLength, code) {

    if( codeLength > 0 ) {
        $$('.off-code-check').css('filter', 'blur(2px)');
        $$('.go-to-bank').css('pointer-events', 'none');
        $$('.off-code-check').css('pointer-events', 'none');

        let couponCodeStatus = await checkCoupon(code);

        if(couponCodeStatus.code == 100) {
            $$('.couponConfirmed').removeClass('d-none');
            $$('.off-code-check').addClass('d-none');

            $$('.off-code-check').css('filter', 'blur(0px)');
            $$('.off-code-check').css('pointer-events', 'all');
            window.localStorage.setItem("couponCode", code);

            $$('.coupon-alert').removeClass('d-none');
            $$('.coupon-alert').html('' + couponCodeStatus.amount +
                ' تخفیف روی صورتحساب شما اعمال شد.');

            // calculatePricesWithOffCode(couponCodeStatus, cart, storageAppetizer);
            return couponCodeStatus;


        } else if(couponCodeStatus.code == 101) {
            $$('.couponConfirmed').addClass('d-none');
            $$('.off-code-check').removeClass('d-none');
            window.localStorage.setItem("couponCode", '');
            incorrectCouponCode.open();
            $$('.off-code-check').css('pointer-events', 'all');
            $$('.off-code-check').css('filter', 'blur(0px)');
            $$('.coupon-alert').addClass('d-none');
            $$('.coupon-alert').html('');

            return false;
        } else {
            $$('.couponConfirmed').addClass('d-none');
            $$('.off-code-check').removeClass('d-none');
            window.localStorage.setItem("couponCode", '');
            notAllowedCoupon.open();
            $$('.off-code-check').css('pointer-events', 'all');
            $$('.off-code-check').css('filter', 'blur(0px)');
            $$('.coupon-alert').addClass('d-none');
            $$('.coupon-alert').html('');

            return false;
        }


    } else {
        $$('.off-code-check').addClass('d-none');
        $$('.go-to-bank').css('pointer-events', 'all');
        $$('.off-code-check').css('pointer-events', 'all');
        $$('.off-code-check').removeClass('codeConfirmed');
        $$('.coupon-alert').addClass('d-none');
        $$('.coupon-alert').html('');

        return false;
    }

}

function checkCoupon(code) {
    var url = baseUrl +'/api/v1/check-coupon';

    let storageCart = JSON.parse(window.localStorage.getItem("cart"));

    let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

    var data = new FormData();

    data.append("platform", platform);
    data.append("version", appVersion);
    data.append("coupon", code);
    Object.keys(storageCart).forEach(function(key) {
        let cartFoodItem = storageCart[key];

        data.append("foods["+ cartFoodItem['id'] +"]", cartFoodItem['count']);
    });
    if(storageAppetizer != undefined && storageAppetizer != [] && storageAppetizer != '' && storageAppetizer.length > 0) {
        Object.keys(storageAppetizer).forEach(function (key) {
            let appetItem = storageAppetizer[key];

            data.append("appetizers[" + appetItem['id'] + "]", appetItem['count']);
        });
    }

    let mobile = window.localStorage.getItem("mobile");
    let confirmationToken = window.localStorage.getItem("confirmationToken");

    var settings = {
        async: true,
        crossDomain: crossDomainParam,
        url: url,
        dataType: "json",
        method: "POST",
        headers: {
            "cache-control": "no-cache",
            "X-AUTH-TOKEN": confirmationToken,
            "X-AUTH-MOBILE": mobile
        },
        processData: false,
        contentType: false,
        mimeType: "multipart/form-data",
        "data": data
    };

    return $.ajax(settings).done(function (response) {
        $$('.go-to-bank').css('pointer-events', 'all');
        return response;
    }).fail(function(response) {
        window.localStorage.setItem("couponCode", '');
        $$('.off-code-check').css('filter', 'blur(0px)');
        $$('.go-to-bank').css('pointer-events', 'all');
        $$('.off-code-check').css('pointer-events', 'all');
        $$('.coupon-alert').addClass('d-none');
        $$('.coupon-alert').html('');
    });
}

function exitApp() {
    navigator.app.exitApp();
}

async function handleBackButton() {
    app.preloader.show('orange');

    let pageName = '';
    if(platform === 'browser') {
        pageName = app.views.main.router.previousRoute.name;
    } else {
        pageName = app.views.main.router.currentRoute.name;
    }

    if(platform !== 'browser' && (pageName == 'home' || pageName == 'login')) {
        exitApp();
    } else if (pageName == 'cart' || pageName == 'location-access' || pageName == 'confirm-code' ||
        pageName == 'address' || pageName == 'about' || pageName == '404') {
        refreshApp();
    } else if (pageName == 'choose-address') {
        // let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));
        // let foodMenu = '';
        // goToCartPage(foodMenu, storageAppetizer);
        refreshApp();
    } else if (pageName == 'purchase') {

        let availableAddresses = await checkAvailableAddresses();
        let foodMenu = '';

        if(availableAddresses.code == 100) {
            let cart = window.localStorage.getItem("cart");
            goToChooseAddressPage(cart, foodMenu, availableAddresses.availableAddresses);
        } else {
            refreshApp();
        }

    } else {
        refreshApp();
    }
}

function handleLoginState() {
    let pageName = app.views.main.router.currentRoute.name;
    let currentUnixTime = Math.round(new Date().getTime()/1000);
    window.localStorage.setItem('loginStateTimestamp', ''+ currentUnixTime +'');
    if(pageName == 'login'){
        window.localStorage.setItem('loginState', 'login');
    }
    if(pageName == 'confirm-code'){
        window.localStorage.setItem('loginState', 'confirm');
    }
}

function renderInvoicesList(userInvoices) {
    if(userInvoices != undefined && userInvoices != null && userInvoices != '' && userInvoices != [] &&
        userInvoices != {} && userInvoices != 'null') {

        let invoiceHtml = '';
        let invoicesList = $$('.invoices-list');

        Object.keys(userInvoices).forEach(function(key) {
            let item = userInvoices[key];
            let invoiceCode = item.code;
            let invoiceTime = 'پرداخت نشده';
            if(item.paymentDoneAt != undefined && item.paymentDoneAt != '' && item.paymentDoneAt != null && item.paymentDoneAt != 'null'){
                invoiceTime = new persianDate(item.paymentDoneAt.date).format('YYYY/MM/DD');
            }

            let invoicePrice = item.sumPrice;
            console.log(item);
            invoiceHtml += '<div class="col-100 desktop-50 invoice-item" data-id="1">' +
                '                            <div class="row top-invoice-item">' +
                '                                <div class="col-66">' +
                '                                    <h2>کد سفارش: ' + invoiceCode +
                '                                    </h2>' +
                '                                </div>' +
                '                                <div class="col-33">' +
                '                                    <div class="col-100 text-left date">' + invoiceTime +
                '</div>' +
                '                                </div>' +
                '                            </div>' +
                '                            <div class="row">' +
                '                                <div class="col-100">' +
                '                                    <p>' + invoicePrice +
                'تومان </p>' +
                '                                </div>' +
                '                            </div>' +
                '                        </div>';
        });

        invoicesList.html(invoiceHtml);

    } else {

    }
}

String.prototype.formatPrice = function() {
    return this.replace(/\d+/g, function(t) {
        return FormatNumberBy3(parseInt(t));
    })
};

function FormatNumberBy3(num, decpoint, sep) {
    // check for missing parameters and use defaults if so
    if (arguments.length == 2) {
        sep = ",";
    }
    if (arguments.length == 1) {
        sep = ",";
        decpoint = ".";
    }
    // need a string for operations
    num = num.toString();
    // separate the whole number and the fraction if possible
    a = num.split(decpoint);
    x = a[0]; // decimal
    y = a[1]; // fraction
    z = "";


    if (typeof(x) != "undefined") {
        // reverse the digits. regexp works from left to right.
        for (i = x.length - 1; i >= 0; i--)
            z += x.charAt(i);
        // add seperators. but undo the trailing one, if there
        z = z.replace(/(\d{3})/g, "$1" + sep);
        if (z.slice(-sep.length) == sep) z = z.slice(0, - sep.length);
        x = "";
        // reverse again to get back the number
        for (i = z.length - 1; i >= 0; i--)
            x += z.charAt(i);
        // add the fraction back in, if it was there
        if (typeof(y) != "undefined" && y.length > 0) x += decpoint + y;
    }
    return x;
}

function handleOpenURL(url) {}

function calculateReceipt(cart, storageAppetizer, offCode=false, wallet=false) {

    $$('.bill-item-main-price b').empty();
    $$('.price-main b').empty();
    $$('.bill-off b').empty();
    $$('.shippmentPrice b').empty();
    $$('.packagingPrice b').empty();

    let off = 0;
    let wal = 0;
    let ceil = 0;

    if (offCode != false) {

        off = parseInt((offCode.amount.toString()).replace('%', ''));
        ceil = parseInt(offCode.ceil);

    };

    if (wallet != false) {
        wal = wallet;
    };

    if( off > 100 ) {
        // toman

        let price = 0;
        let priceBeforeOff = 0;

        Object.keys(cart).forEach(function(key) {

            if(cart[key]!= null) {
                let count = cart[key].count;
                let mainPrice = cart[key].price;
                let mainPriceWithOff = cart[key].priceWithOff;

                priceBeforeOff = priceBeforeOff + parseInt(mainPrice * count);

                if (mainPrice === mainPriceWithOff) {
                    price = price + parseInt(mainPrice * count);
                } else {
                    price = price + parseInt(mainPriceWithOff * count);
                }
            }

        });

        let appetPrice = 0;
        if (storageAppetizer !== undefined) {
            Object.keys(storageAppetizer).forEach(function (key) {

                if (storageAppetizer[key] != null && storageAppetizer != []) {
                    let count = storageAppetizer[key].count;
                    let mainPrice = storageAppetizer[key].price;

                    appetPrice = appetPrice + parseInt(mainPrice * count);
                }

            });
        }

        let finalPriceWithoutOffcodeAndWallet = parseInt(price) + parseInt(appetPrice);
        let finalPriceWithOffCode = finalPriceWithoutOffcodeAndWallet - off;
        let finalPriceWithWallet = (finalPriceWithOffCode + parseInt(shippmentPrice) + parseInt(packagingPrice)) - wal;

        $$('.bill-item-main-price b').append(''+ (finalPriceWithWallet).toString().formatPrice() +' تومان');

        let priceBeforeOffFinal = priceBeforeOff + appetPrice;
        let sumOff = (priceBeforeOff - price) + off;

        $$('.price-main b').append(''+ priceBeforeOffFinal.toString().formatPrice() +' تومان');
        $$('.bill-off b').append(''+ sumOff.toString().formatPrice() +' تومان');
        $$('.shippmentPrice b').append(shippmentPrice.toString().formatPrice() + ' تومان ');
        $$('.packagingPrice b').append(packagingPrice.toString().formatPrice() + ' تومان ');

    } else {
        // percent

        let price = 0;
        let priceBeforeOff = 0;

        Object.keys(cart).forEach(function(key) {

            if(cart[key]!= null) {
                let count = cart[key].count;
                let mainPrice = cart[key].price;
                let mainPriceWithOff = cart[key].priceWithOff;

                priceBeforeOff = priceBeforeOff + parseInt(mainPrice * count);

                if (mainPrice === mainPriceWithOff) {
                    price = price + parseInt(mainPrice * count);
                } else {
                    price = price + parseInt(mainPriceWithOff * count);
                }
            }

        });

        let appetPrice = 0;
        if (storageAppetizer !== undefined) {
            Object.keys(storageAppetizer).forEach(function (key) {

                if (storageAppetizer[key] != null && storageAppetizer != []) {
                    let count = storageAppetizer[key].count;
                    let mainPrice = storageAppetizer[key].price;

                    appetPrice = appetPrice + parseInt(mainPrice * count);
                }

            });
        }

        let finalPriceWithoutOffcodeAndWallet = parseInt(price) + parseInt(appetPrice);
        let finalPriceWithOffCode = (finalPriceWithoutOffcodeAndWallet * (100-off))/100;

        let offPrice = (finalPriceWithoutOffcodeAndWallet * off)/100;

        if( ((finalPriceWithoutOffcodeAndWallet * off)/100) > ceil ) {
            finalPriceWithOffCode = finalPriceWithoutOffcodeAndWallet - ceil;
        };

        if( offPrice > ceil ) {
            offPrice = ceil;
        };

        let finalPriceWithWallet = (finalPriceWithOffCode + parseInt(shippmentPrice) + parseInt(packagingPrice)) - wal;

        $$('.bill-off b').append(''+ ((priceBeforeOff - price) + offPrice).toString().formatPrice() +' تومان');

        $$('.bill-item-main-price b').append(''+ finalPriceWithWallet.toString().formatPrice() +' تومان');

        var priceBeforeOffFinal = priceBeforeOff + appetPrice;

        $$('.price-main b').append(''+ priceBeforeOffFinal.toString().formatPrice() +' تومان');


        $$('.shippmentPrice b').append(shippmentPrice.toString().formatPrice() + ' تومان ');
        $$('.packagingPrice b').append(packagingPrice.toString().formatPrice() + ' تومان ');

    }

    TraceNodes(document);
};

function handleWalletUI() {
    $$('.wallet-in-purchase').empty();
    $$('.wallet-in-purchase').append(''+ user.wallet.toString().formatPrice() +' تومان');
    $$('.wallet-in-purchase').attr('data-wallet', user.wallet);
}

function handleBankUI() {
    $$('.bank-item').click(function() {
        $$('.bank-item').each(function(){
            $$(this).removeClass('active-bank');
        });
        $$(this).addClass('active-bank');
    });
}

function handleOffCodeUI() {

    $$('.off-code-title').click(function(){
        window.localStorage.setItem("couponCode", '');
        $$(this).toggleClass('d-none');
        $$('.off-code input').toggleClass('d-none');
        $$('.off-code input').focus();
    });

}