class Invoice {

    constructor (address, gateway, coupon, foods, totalPrice, appetizers, description) {
        this.address = address;
        this.gateway = gateway;
        this.coupon = coupon;
        this.totalPrice = totalPrice;
        this.foods = foods;
        this.appetizers = appetizers;
        this.description = description;
    }

    async sendInvoice(wallet, bank, offCode, description, useWallet) {

        var url = baseUrl +'/api/v1/new-invoice';

        let storageCart = JSON.parse(window.localStorage.getItem("cart"));

        let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));

        var price = 0;
        var appetPrice = 0;

        Object.keys(storageCart).forEach(function(key) {
            price = price + parseInt(storageCart[key].priceWithOff * storageCart[key].count);
        });

        if(storageAppetizer != undefined && storageAppetizer != [] && storageAppetizer != '' && storageAppetizer.length > 0) {
            Object.keys(storageAppetizer).forEach(function(key) {
                appetPrice = appetPrice + parseInt(storageAppetizer[key].price * storageAppetizer[key].count);
            });
        };

        price = price + parseInt(shippmentPrice) + parseInt(packagingPrice) + parseInt(appetPrice);

        let mobile = window.localStorage.getItem("mobile");
        let confirmationToken = window.localStorage.getItem("confirmationToken");
        let selectedAddress = window.localStorage.getItem("selectedAddress");

        if(storageCart !== null) {

            var data = new FormData();

            data.append("platform", platform);
            data.append("version", appVersion);
            data.append("address", selectedAddress);
            data.append("gateway", bank);
            data.append("coupon", offCode);
            data.append("wallet", useWallet);
            Object.keys(storageCart).forEach(function(key) {
                let cartFoodItem = storageCart[key];

                data.append("foods["+ cartFoodItem['id'] +"]", cartFoodItem['count']);
            });
            if(storageAppetizer != undefined && storageAppetizer != [] && storageAppetizer != '' && storageAppetizer.length > 0) {
                Object.keys(storageAppetizer).forEach(function (key) {
                    let appetItem = storageAppetizer[key];

                    data.append("appetizers[" + appetItem['id'] + "]", appetItem['count']);
                });
            }
            data.append("totalPrice", price);
            data.append("descriptions", description);

            let preorderId = window.localStorage.getItem("preorderId");

            if(preorderId != undefined && preorderId != null && preorderId != '') {
                Object.keys(user.preorderTimes).forEach(function(key) {
                    var item =  user.preorderTimes[key];
                    if(preorderId == item.id){
                        data.append("preorder", preorderId);
                    }
                });
            }

            var settings = {
                async: true,
                crossDomain: crossDomainParam,
                url: url,
                dataType: "json",
                method: "POST",
                headers: {
                    "cache-control": "no-cache",
                    "X-AUTH-TOKEN": confirmationToken,
                    "X-AUTH-MOBILE": mobile
                },
                processData: false,
                contentType: false,
                mimeType: "multipart/form-data",
                "data": data
            };

            return $.ajax(settings).done(function (response) {
                return response;
            }).fail(function(response) {

                // console.log(response.code);
                noInternet.open();

                $('.go-to-bank').html('پرداخت');

                $$('.go-to-bank').css('pointer-events', 'all');
            });
        } else {
            noInternet.open();

            $('.go-to-bank').html('پرداخت');

            $$('.go-to-bank').css('pointer-events', 'all');
        }
    }
}
