function loginPageInit() {

    handleLoginState();

    $$('.mobile-input').focus();

    handleLoginBtnUi();

    handleLoginBtnClick();

    TraceNodes(document);

}

function confirmPageInit(mobile) {

    handleLoginState();

    $$('.mobile-sms').empty();

    $$('.mobile-sms').append(''+ mobile +'');

    sendAgainCodeTimer();

    handleConfirmCodeInputs(mobile);

    $$('.change-mobile').click(function(){

        goToLoginPage();

    });

    $$('.resend-code').click(function(){

        $$('.resend-code').hide();

        $$('.resend-code').css('pointer-events', 'none');

        user.login(mobile, function (response) {

            if(response['code'] === 100) {

                sendAgainCodeTimer();

            }

        });

    });

    TraceNodes(document);
}

function locationPageInit() {

    app.preloader.hide();

    if(platform === 'browser') {
        $$('button.location-access-btn').on('click', function () {

            getLocation();

        });
    } else {
        $$('button.location-access-btn').on('click', async function () {
            window.localStorage.setItem("locationAccess", true);

            let blocker = await getLocationAccessMobile(true);
            setTimeout(function () {
                refreshApp();
            }, 5000);
        });
    }

    TraceNodes(document);

}

async function homePageInit(lat, lng, locationName, page=false) {

    await orderTimeStatus();

    if (handleLastSubmit()) return false;
    let storageLat = '';
    let storageLng = '';

    if(lat !== undefined && lat != null && lat !== '' && lng !== undefined && lng != null && lng !== '') {
        storageLat = lat;
        storageLng = lng;
    }

    if(locationName !== undefined && locationName != null && locationName !== '') {
        renderLocationNameInNavbar(locationName);
    }

    let foodContainer = $$('#foods-container');
    foodContainer.empty();
    foodContainer.append('');

    let menu = new Menu();
    let cart = new Cart();

    let appetizer = new Appetizer();

    let foodMenu = undefined;

    try {

        let blocker = await menu.getMenuData(storageLat, storageLng);
        foodMenu = menu.menuList;

    } catch (e) {

        foodMenu = undefined;

    }

    let cartList = await cart.getCartData();
    let appetizerList = await appetizer.getAppetizerData();

    let preOrder = localStorage.getItem("preorderId");

    let hour = new Date().getHours();

    if ( foodMenu !== undefined && foodMenu.length !== 0 ) {

        renderFoodMenu(foodMenu);

        // if ( preOrder != '' && preOrder > 0 && preOrder != undefined && preOrder != null ) {
        //
        //     renderFoodMenu(foodMenu);
        //
        // } else if ( !canOrderNow ) {
        //
        //     let notAvailableFoodImage = '';
        //     if( user.userData.noFoodImage != undefined &&  user.userData.noFoodImage != null ) {
        //         notAvailableFoodImage = user.userData.noFoodImage;
        //     }
        //
        //     let foodContainer = $$('#foods-container');
        //     foodContainer.empty();
        //
        //     foodContainer.append('<p class="notavailablefood">' +
        //         '<img src="'+ notAvailableFoodImage +'" class="no-food-available" alt="" />' +
        //         'در حال حاضر امکان ثبت پیش‌سفارش فراهم است' +
        //         '</p>' +
        //         '<p class="notavailablefood"><a class="go-to-pre-order btn cart-btn" style="padding-right: 8px;padding-left: 8px;margin-right: 0px!important;">پیش سفارش</a></p>');
        //
        // } else {
        //
        //     renderFoodMenu(foodMenu);
        //
        // }


    } else {

        let notAvailableFoodImage = '';
        if( user.userData.noFoodImage != undefined &&  user.userData.noFoodImage != null ) {
            notAvailableFoodImage = user.userData.noFoodImage;
        }

        let foodContainer = $$('#foods-container');
        foodContainer.empty();

        foodContainer.append('<p class="notavailablefood">' +
            '<img src="'+ notAvailableFoodImage +'" class="no-food-available" alt="" />' +
            'در حال حاضر امکان ثبت پیش‌سفارش فراهم است' +
            '</p>' +
            '<p class="notavailablefood"><a class="go-to-pre-order btn cart-btn" style="padding-right: 8px;padding-left: 8px;margin-right: 0px!important;">پیش سفارش</a></p>');

    }

    if (cartList !== undefined && cartList.length != 0) {

        renderCartList(cartList, foodMenu, cart);

        if (appetizerList !== undefined && appetizerList.length != 0) {
            renderAppetizerList(appetizerList, foodMenu);
        }

    } else {

        window.localStorage.setItem("appetizer", "[]");

        let updatedAppet = JSON.parse(window.localStorage.getItem("appetizer"));

        renderAppetizerList(updatedAppet, foodMenu);

    }

    addFoodToCart(foodMenu, cart);

    addAppetizerToCart(foodMenu);

    removeFoodFromCart(foodMenu, cart);

    removeAppetizerFromCart(foodMenu, cart);

    $$('.go-to-cart-btn').on('click', function() {

        let storageCart = JSON.parse(window.localStorage.getItem("cart"));
        let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));
        let foodItems = $$('#foods-container .food-item');

        let sidebarCart = $$('.simplebar-content .cart-item');

        if( storageCart === null && sidebarCart.length == 0 ) {
            storageCart = [];
        }

        if (foodItems.length == 0 || storageCart === undefined || storageCart === '' || storageCart === null || storageCart.length === 0) {

            emptyCartNotif.open();

        } else {

            goToCartPage(foodMenu, storageAppetizer);

        };

    });

    $$('.go-to-address-page').on('click', function () {
        goToAddressPage(storageLat, storageLng);
    });

    renderSidebarData();

    cartItemHeightHandle();

    TraceNodes(document);

    app.preloader.hide();

    $$('.go-to-pre-order').on('click', function(){
        preorder.open();
    });

    // if(Object.keys(user.preorderTimes).length > 0 && user.preorderTimes != undefined &&
    //     user.preorderTimes != '' && user.preorderTimes != null && user.preorderTimes != {} && user.preorderTimes != []) {
    //
    // } else {
    //     notAllowedPreorder.open();
    // }

}

function cartPageInit(foodMenu, storageAppetizer, page=false) {

    window.localStorage.removeItem("foodMenu");

    renderSidebarData();

    renderPreorderText();

    let cart = JSON.parse(window.localStorage.getItem("cart"));

    renderCartPageItems(cart, foodMenu, storageAppetizer);

    calculatePrices(cart, storageAppetizer);

    increaseFoodCartPage(cart, foodMenu, storageAppetizer);

    decreaseFoodCartPage(cart, foodMenu, storageAppetizer);

    handleReciept();

    $$('.cart-page-next-btn').on('click', async function(){

        let addresses = user.userData.user.data['addresses'];
        if(addresses == null) {
            addresses = [];
        }
        let addressesLength = Object.keys(addresses).length;

        if(cart == '' || cart == null || cart == undefined || cart == []) {
            cart = [];
        }

        if(cart.length > 0) {

            var domCart = $('#cart-page-items .cart-food-item').hasClass('cart-page-no-stock');

            if(domCart == true) {
                pleaseRemove.open();
            } else {

                $$('.cart-page-next-btn a').html('صبر کنید');
                $$('.cart-page-next-btn').css('pointer-events', 'none');

                if(addressesLength>0) {
                    let availableAddresses = await checkAvailableAddresses();

                    if(availableAddresses.code == 100) {
                        goToChooseAddressPage(cart, foodMenu, availableAddresses.availableAddresses);
                    } else {
                        $$('.cart-page-next-btn a').html('انتخاب آدرس');
                        $$('.cart-page-next-btn').css('pointer-events', 'all');

                        noInternet.open();
                    }
                } else {
                    $$('.cart-page-next-btn a').html('انتخاب آدرس');
                    $$('.cart-page-next-btn').css('pointer-events', 'all');

                    goToChooseAddressPage(cart, foodMenu);
                }

            }

        } else {

            emptyCartNotif.open();
        }

    });

    $$('.backToHome').on('click', async function() {
        let locationData = locationForHomePageInit(user);
        goToHomePage(locationData[0], locationData[1], locationData[2]);
    });

    TraceNodes(document);

}

function addressPageInit(storageLat, storageLng) {

    renderSidebarData();

    var url = 'https://map.ir/search/autocomplete';

    var locationListContainer = $$('.location-lists');

    var textOne = $$('input.location-search-name').val();

    if(textOne.length == 0) {
        $.ajax({
            method: 'POST',
            cache: false,
            headers: {
                'x-api-key': mapApiKey
            },
            data: {
                "text": 'ا',
                "$filter": "province eq تهران",
                "location": {
                    "type": "Point",
                    "coordinates": [
                        51.3361930847168,
                        35.7006311416626
                    ]
                }
            },
            url: url,
            success: function (response) {

                // console.log(response);

                var locationListHtml = '';

                Object.keys(response.value).forEach(function(key) {

                    if(response.value[key] != null && response.value[key] != '' && response.value[key] != undefined) {

                        var title = response.value[key].Title;
                        var address = response.value[key].Address;
                        var text = response.value[key].Text;
                        var lat = response.value[key].Coordinate.lat;
                        var lng = response.value[key].Coordinate.lon;

                        locationListHtml += '<li data-lat="'+ lat +'" data-lng="'+ lng +'"><h3 class="loc-title">'+ title +'</h3>' +
                            '<p>'+ address +'</p></li>'

                    }

                });

                locationListContainer.empty();
                locationListContainer.append(locationListHtml);

            }
        });
    }

    $$('input.location-search-name').keyup(function() {

        var text = $$('input.location-search-name').val();

        if(text.length > 0) {
            $.ajax({
                method: 'POST',
                cache: false,
                headers: {
                    'x-api-key': mapApiKey
                },
                data: {
                    "text": text,
                    "$filter": "province eq تهران",
                    "location": {
                        "type": "Point",
                        "coordinates": [
                            51.3361930847168,
                            35.7006311416626
                        ]
                    }
                },
                url: url,
                success: function (response) {

                    // console.log(response);

                    var locationListHtml = '';

                    Object.keys(response.value).forEach(function(key) {

                        if(response.value[key] != null && response.value[key] != '' && response.value[key] != undefined) {

                            var title = response.value[key].Title;
                            var address = response.value[key].Address;
                            var text = response.value[key].Text;
                            var lat = response.value[key].Coordinate.lat;
                            var lng = response.value[key].Coordinate.lon;

                            locationListHtml += '<li data-lat="'+ lat +'" data-lng="'+ lng +'"><h3 class="loc-title">'+ title +'</h3>' +
                                '<p>'+ address +'</p></li>'

                        }

                    });

                    locationListContainer.empty();
                    locationListContainer.append(locationListHtml);

                }
            });
        } else {
            locationListContainer.empty();
        }
    });

    $$(document).on('click', '.location-lists li', async function() {

        var lat = $$(this).attr('data-lat');
        var lng = $$(this).attr('data-lng');

        let currentUnixTime = Math.round(new Date().getTime()/1000);

        window.localStorage.setItem("lat", lat);
        window.localStorage.setItem("lng", lng);
        window.localStorage.setItem('selectedAddress', 'no');
        window.localStorage.setItem('locationUpdateTimestamp', currentUnixTime);
        refreshApp();

        // goToHomePage(lat, lng, locationName.name);

    });

    let addresses = user.userData.user.data['addresses'];

    if(addresses != '') {

        renderAddresses(addresses, false, true);
        handleAddressDelete();

    } else {
        $$('.no-address').append('<p class="no-address">' +
            'شما هنوز آدرسی ثبت نکرده‌اید' +
            '</p>');
        $$('.no-address-new-address').show();
    }

    $$(document).on('click', '.address-item', function() {
        $$('.address-item').each(function(){
            $$(this).removeClass('active-address');
        });
        $$(this).addClass('active-address');
    });

    $$('.backToCart').on('click', async function() {
        // goToCartPage(foodMenu, storageAppetizer);

        let locationData = await locationForHomePageInit(user);
        let lat = locationData[0];
        let lng = locationData[1];
        let locationName = locationData[2];
        goToHomePage(lat, lng, locationName);

    });

    $$('.backToHome').on('click', async function() {
        refreshApp();

    });

    // Open dynamic popup
    $$(document).on('click', '.add-address-btnn', function () {
        dynamicPopup.open();
    });

    $$(document).on('click', '.address-menu-address-selector', function () {
        if (handleLastSubmit()) {
            return false;
        }
        let id = $$(this).attr('item-id');
        addresses = user.userData.user.data['addresses'];

        let currentUnixTime = Math.round(new Date().getTime()/1000);

        window.localStorage.setItem('lat', addresses[id].lat);
        window.localStorage.setItem('lng', addresses[id].lon);
        window.localStorage.setItem('selectedAddress', id);
        window.localStorage.setItem('locationUpdateTimestamp', currentUnixTime);
        refreshApp();

    });

    TraceNodes(document);

}

function chooseAddressPageInit(oCart, foodMenu, availableAddresses) {

    if(availableAddresses.length < 1) {
        $$('.addresses').hide();
    } else {
        $$('.addresses').show();
    }

    renderSidebarData();

    renderPreorderText();

    handleReciept();

    window.localStorage.setItem("foodMenu",JSON.stringify(foodMenu));

    let cart = JSON.parse(window.localStorage.getItem("cart"));

    let storageAppetizer = JSON.parse(window.localStorage.getItem("appetizer"));
    let selectedAddress = window.localStorage.getItem("selectedAddress");

    if(selectedAddress != undefined && selectedAddress != '' && selectedAddress != 'no' && selectedAddress != null) {

        let counter = 0;
        Object.keys(availableAddresses).forEach(function(key) {
            // console.log('asd');
            let addressItem = availableAddresses[key];
            if(addressItem.address == selectedAddress && counter == 0) {
                calculatePrices(cart, storageAppetizer, addressItem.delivery);
                counter++;
            }
        });

    } else {
        calculatePrices(cart, storageAppetizer);
    }

    let addresses = user.userData.user.data['addresses'];

    if(addresses != '') {

        renderAddresses(addresses, availableAddresses);
        handleAddressDelete();
        // handleAddressEdit();

    } else {
        $$('.no-address').append('<p class="no-address">' +
            'شما هنوز آدرسی ثبت نکرده‌اید' +
            '</p>');
        $$('.no-address-new-address').show();
    }

    $$(document).on('click', '.address-item', function() {
        var notAllowedAddress = $$(this).hasClass('deactiveAddress');

        if(notAllowedAddress != true) {
            $$('.address-item').each(function(){
                $$(this).removeClass('active-address');
            });
            $$(this).addClass('active-address');

            let shPrice = $$(this).attr('shippment-price');

            calculatePrices(cart, storageAppetizer, shPrice);
        } else {
            notAllowedAddressNotif.open();
        }
    });

    $$('.go-to-purchase').on('click', function(){
        window.localStorage.removeItem("foodMenu");

        let activeAddress = $$('.active-address');
        let activeAddressId = $$('.active-address').attr('item-id');

        if (activeAddress.length > 0) {

            window.localStorage.setItem("selectedAddress", activeAddressId);

            goToPurchasePage(cart, foodMenu, storageAppetizer);
        } else {
            emptyAddress.open();
        }
    });

    $$('.backToCart').on('click', function() {
        goToCartPage(foodMenu, storageAppetizer);
    });

    // Open dynamic popup
    $$(document).on('click', '.add-address-btnn', function () {
        dynamicPopup.open();
    });

    TraceNodes(document);
}

function purchasePageInit(cart, foodMenu, storageAppetizer) {

    let invoice = new Invoice();
    window.localStorage.setItem("couponCode", '');

    calculateReceipt(cart, storageAppetizer);

    renderSidebarData();
    handleBankUI();
    handleWalletUI();
    handleOffCodeUI();

    renderPreorderText();
    // handle Reciept UI
    handleReciept();

    let codeLength = 0;
    let code = '';
    $$('.coupon-input').on('change paste keyup', function() {
        code = $$(this).val();
        codeLength = code.length;
        if( codeLength > 0 ) {
            $$('.off-code-check').removeClass('d-none');
        } else {
            $$('.off-code-check').addClass('d-none');
            window.localStorage.setItem("couponCode", '');
            $$('.codeConfirmed').addClass('d-none');
        }
    });

    $$(document).on('click', '.off-code-check', async function () {

        let codeStatus = await handleCouponCode(codeLength, code);

        let toggleState = app.toggle.get('.toggle');

        if(toggleState.checked) {

            calculateReceipt(cart, storageAppetizer, codeStatus, user.wallet);

        } else {

            calculateReceipt(cart, storageAppetizer, codeStatus);

        };

    });

    $$(document).on('click', '.couponConfirmed', function(){

        window.localStorage.setItem("couponCode", '');
        $$('.coupon-input').val("");
        $$('.couponConfirmed').addClass('d-none');
        // $$('.off-code-check').html('ثبت');
        $$('.off-code-check').addClass('d-none');
        $$('.off-code input').focus();
        $$('.coupon-alert').addClass('d-none');
        $$('.coupon-alert').html('');

        let codeStatus = false;

        let toggleState = app.toggle.get('.toggle');

        if(toggleState.checked) {

            calculateReceipt(cart, storageAppetizer, codeStatus, user.wallet);

        } else {

            calculateReceipt(cart, storageAppetizer, codeStatus);

        };

    });

    let wallet = 0;
    let useWallet = 0;

    let toggle = app.toggle.create({
        el: '.toggle',
        on: {
            change: async function () {

                let checkCodeStatus = false;

                if($$('.coupon-input').val() != '' && $$('.coupon-input').val() != null) {
                    checkCodeStatus = await handleCouponCode(codeLength, code);
                }

                if (toggle.checked) {

                    $$('.wallet-alert').removeClass('d-none');
                    $$('.wallet-alert').html('مبلغ ' +
                        user.wallet + ' تومان' +
                        ' روی صورتحساب اعمال شد');

                    calculateReceipt(cart, storageAppetizer, checkCodeStatus, user.wallet);

                    wallet = user.wallet;

                    if(wallet > 0) {

                        useWallet = 1;

                    } else {

                        wallet = 0;
                        useWallet = 0;

                    }

                } else {

                    $$('.wallet-alert').addClass('d-none');
                    $$('.wallet-alert').html('');

                    calculateReceipt(cart, storageAppetizer, checkCodeStatus);

                    wallet = 0;
                    useWallet = 0;

                }

            }
        }
    });

    $(document).on('click', '.go-to-bank', async function(){

        $(this).html('لطفا صبر کنید');

        $$(this).css('pointer-events', 'none');

        var bank = $$('.active-bank').attr('data-name');

        let couponCode = window.localStorage.getItem("couponCode");

        if($$('.off-code input').val().length > 0 && couponCode != undefined && couponCode != '' && couponCode == $$('.off-code input').val()) {
            var offCode = couponCode;
        } else {
            var offCode = '';
        }

        if($$('.order-description textarea').val().length > 0) {
            var description = $$('.order-description textarea').val();
        } else {
            var description = '-';
        }

        let sendInvoiceStatus = await invoice.sendInvoice(wallet, bank, offCode, description, useWallet);

        if (sendInvoiceStatus.code === 100) {

            $('.go-to-bank').html('پرداخت');

            $$('.go-to-bank').css('pointer-events', 'all');

            window.localStorage.setItem("cart", "[]");
            window.localStorage.setItem("selectedAddress", "");

            if(platform !== 'browser') {
                window.location = baseUrl + sendInvoiceStatus.url;
                setTimeout(function(){
                    refreshApp();
                },2000);
            } else {
                if (("standalone" in window.navigator) &&
                    !window.navigator.standalone){

                        window.open(
                            baseUrl + sendInvoiceStatus.url,
                            '_blank'
                        );

                } else {

                    window.location = baseUrl + sendInvoiceStatus.url;

                    setTimeout(function(){
                        refreshApp();
                    },2000);

                    return false;

                }
            }

        } else if (sendInvoiceStatus.code === 101) {
            $$('.go-to-bank').css('pointer-events', 'all');

            invalidAddressNotif.open();

        } else if (sendInvoiceStatus.code === 102) {
            $$('.go-to-bank').css('pointer-events', 'all');

            unavailableFoods.open();

        } else if (sendInvoiceStatus.code === 103) {
            $$('.go-to-bank').css('pointer-events', 'all');

            unavailableAppetizers.open();

        } else if (sendInvoiceStatus.code === 105) {
            $$('.go-to-bank').css('pointer-events', 'all');

            invalidInvoice.open();

        }

    });

    $$('.backToChooseAddress').on('click', async function() {

        let availableAddresses = await checkAvailableAddresses();

        if(availableAddresses.code == 100) {
            goToChooseAddressPage(cart, foodMenu, availableAddresses.availableAddresses);
        } else {
            refreshApp();
        }

    });

    TraceNodes(document);
}

function invoicesPageInit() {

    let userInvoices = user.invoices;

    renderSidebarData();

    renderInvoicesList(userInvoices);

    $$(document).on('click', '.backToHome', function(){
        refreshApp();
    });

    TraceNodes(document);

    // $$(document).on('click', '.invoice-item', function() {
    //     var itemId = $$(this).attr('data-id');
    //
    //     // goToSingleInvoice(itemId);
    // })
}

// function singleInvoicePageInit(itemId) {
//     console.log('asd');
// }

function receiptPageInit() {
    // setTimeout(function() {
    //     app.views.main.router.navigate('/', {
    //         pushState: true,
    //         on: {
    //             pageInit: function (page) {
    //                 homePageInit()
    //             }
    //         }
    //     });
    // }, 15000);

    TraceNodes(document);
}

document.addEventListener("backbutton", handleBackButton, false);

window.onhashchange = function() {
    handleBackButton();
};

function termsPageInit() {
    renderSidebarData();

    $$('.backToHome').on('click', async function() {
        refreshApp();
    });

    $$('#terms-container').html('<div class="row"><p>' +
        '' +
        '                    ۱. اجاق تابع قوانین جمهوری اسلامی ایران است، درج هر گونه مطلب سیاسی، خلاف مقررات جمهوری اسلامی ایران و غیر اخلاقی باعث حذف حساب کاربر می شود.' +
        '                    <br>' +
        '                    <br>' +
        '                    ۲. مشتری موظف است در زمان ثبت سفارش آدرس و شماره تماس صحیح وارد نماید و قبل از ثبت سفارش نهایی لیست انتخابی خود را به دقت چک کند.' +
        '                    <br>' +
        '                    <br>' +
        '                    ۳. اگر پس از ثبت و تایید سفارش، تلفن شما در دسترس نباشد و در آدرسی که وارد کرده اید حضور نداشته باشید، سفارش شما لغو و مبلغ پرداختی عودت داده نمی شود.' +
        '                    <br>' +
        '                    <br>' +
        '                    ۴. اجاق متعهد می شود اطلاعات کاربران را محفوظ نگه دارد و بدون اجازه کاربر آن را در اختیار غیر قرار ندهد.' +
        '                    <br>' +
        '                    <br>' +
        '                    ۵. پرداخت مبلغ سفارشات در اجاق تنها از طریق پرداخت آنلاین و شارژ کیف پول انجام می&zwnj;شود.' +
        '                    <br>' +
        '                    <br>' +
        '                    ۶. گرافیک،&zwnj; تصاویر و متون استفاده شده در سایت و اپلیکیشن اجاق متعلق به شرکت نوآوران صنعت غذایی اجاق می باشد و کپی برداری به هر صورتی پیگرد قانونی دارد.' +
        '                    <br>' +
        '                    <br>' +
        '                    ۷. امکان تحویل و پرداخت مبلغ سفارش به صورت حضوری وجود ندارد.' +
        '</p></div>');

    TraceNodes(document);
}

function aboutPageInit() {
    renderSidebarData();

    $$('.backToHome').on('click', async function() {
        refreshApp();
    });

    $$('#about-container').html('<div class="row"><p>' +
        '                        اجاق از یک فکر و نیاز اولیه شروع شد و با همراهی تیمی خلاق،‌ پویا و پرانرژی در محیطی بسیار صمیمانه شکل گرفت و کم کم در تهران رشد پیدا کرد.' +
        '                        اجاق به شما این امکان را می دهد که به سادگی چند کلیک غذای سنتی و خوشمزه، (آش، حلیم و کله پاچه) با بالاترین کیفیت در سطح تهران را سفارش دهید و درب منزل خود تحویل بگیرید.' +
        '                        <br>' +
        '                        <br>' +
        '                        زمانی که شما، سفارش ثبت می کنید اپراتور اجاق، با نزدیک ترین تامین کننده تماس می گیرد و لیست سفارش را اعلام می کند و تا زمانی که سفارش شما بسته بندی شود، برای تامین کننده پیک موتوری می فرستد و غذای شما را در کمترین زمان ممکن به شما تحویل خواهد داد.' +
        '                        لازم به ذکر است ملزومات بسته بندی از قبل در اختیار تامین کنندگان قرار گرفته است و با پکیجینگ منحصر به اجاق، غذا را دریافت خواهید کرد.' +
        '                        <br>' +
        '                        <br>' +
        '                        اجاق تمام تلاش خود را می کند که سفارش پس از ثبت و تایید در سریع ترین زمان ممکن به دست شما برسد.' +
        '                        <br>' +
        '                        <br>' +
        '                        تیم اجاق در تلاش است که خدمات و فرآیند سفارش آسان تری برای شما به ارمغان بیاورد تا بتوانید غذای سنتی را به راحتی به صورت آنلاین سفارش دهید.' +
        '                        <br>' +
        '                        <br>' +
        '                        پس از گذشت کمتر از یک سال توانسته ایم تعداد قابل توجهی مشتری راضی و تامین کننده هایی با سطح کیفی A در کنار خودمان داشته باشیم.' +
        '                        <br>' +
        '                        <br>' +
        '                        شما به راحتی می توانید با وارد کردن یک شماره موبایل در اجاق ثبت نام و به صورت اتوماتیک منوی نزدیک ترین رستوران به خودتان را مشاهده کنید.' +
        '                        <br>' +
        '                        <br>' +
        '' +
        '                        <b>برنامه اجاق برای آینده چیست؟</b>' +
        '' +
        '                        <br>' +
        '                        اجاق در تلاش است بزودی لیست غذای خود را با توجه به ارزش ها و ملاک های مورد نظر، با همکاری بهترین تامین کنندگان در تهران کامل تر کند.' +
        '' +
        '                        <br>' +
        '                        <br>' +
        '' +
        '                        <b>چرا باید از اجاق استفاده کنم؟</b>' +
        '' +
        '                        <br>' +
        '                        <br>' +
        '                        -ثبت نام آسان با یک شماره تماس' +
        '                        <br>' +
        '                        -فرایند سفارش دهی بسیار آسان' +
        '                        <br>' +
        '                        -بالاترین سطح کیفی غذا در سطح تهران' +
        '                        <br>' +
        '                        -ارسال در سریع ترین زمان ممکن' +
        '                        <br>' +
        '                        -امکان سفارش دهی به صورت پیش سفارش' +
        '                        <br>' +
        '                        -ارائه قیمت های مناسب و رقابتی' +
        '                        <br>' +
        '                        -قابلیت مکان یابی خودکار' +
        '                        <br>' +
        '                        -ذخیره سازی آدرس های شما' +
        '                        <br>' +
        '                        -جستجو خودکار آدرس و چینش خودکار منو براساس تامین کنندگان منطقه شما' +
        '                        <br>' +
        '' +
        '                        <br>' +
        '                        <br>' +
        '' +
        '                    </p></div>');

    TraceNodes(document);
}

function privacyPageInit() {
    renderSidebarData();

    $$('.backToHome').on('click', async function() {
        refreshApp();
    });

    $$('#privacy-container').html('<div class="row"><p>' +
        '۱.                         سامانه اجاق برای اطلاعات و حریم شخصی کاربران احترام بسیار زیادی قائل است،‌ لازم به ذکر است کلیه اطلاعات از جمله: نام، نام خانوادگی، ایمیل، شماره تماس و … نزد سامانه اجاق محفوظ بوده و بدون اطلاع کاربر در اختیار هیچ شخص و سازمانی قرار نمی گیرد مگر با حکم قضایی و مطابق با قوانین کشور.' +
        '                        <br>' +
        '                        <br>' +
        '                        ۲. شما با ثبت نام در سامانه اجاق شماره تماس خود را وارد می کنید و در ادامه برای ثبت سفارش نیاز به اضافه کردن نام، نام خانوادگی و آدرس دارید.' +
        '                        <br>' +
        '                        <br>' +
        '۳.                         کلیه تراکنش ها و پرداختی های شما در اختیار سامانه اجاق قرار می گیرد. لازم به ذکر است اجاق مانند سایر وب سایت ها کوکی ها و ip هارا جمع آوری می کند، اما لایه های امنیتی اجاق با روش درست مدیریت اطلاعات تمام تلاش خود را می کند که از اطلاعات کاربران محافظت کند.' +
        '                        <br>' +
        '                        <br>' +
        '                        ۴. ارتباط با مشتریان جهت پیگیری سفارش و اطلاع رسانی رویدادهای مربوط به اجاق از طریق پیامک، ایمیل و تماس تلفنی برقرار می شود، لازم به ذکر است در اپلیکیشن اجاق هیچ اطلاع رسانی (push notification) انجام نمی شود.' +
        '                        <br>' +
        '                        <br>' +
        '۵.                         اگر کاربر علاقه ای به دریافت ایمیل ها نداشته باشد،‌ در انتهای ایمیل از طریق گزینه لغو عضویت در خبرنامه می تواند ارسال ایمیل هارا متوقف کند.' +
        '                        <br>' +
        '                        <br>' +
        '۶.                         شما می توانید تمام اطلاعات مندرج در پروفایل خود را به راحتی ویرایش کنید، این اطلاعات شامل مواردی است که در سامانه اجاق وارد کرده اید.' +
        '                        <br>' +
        '                        <br>' +
        '                        ۷. سامانه اجاق دسترسی های گوناگونی برای تیم خود در نظر گرفته و هر فرد با توجه به نیاز خود به اطلاعات کاربران دسترسی پیدا می کند.' +
        '                        <br>' +
        '                        <br>' +
        '۸.                         در این سامانه نیازی به بخاطر سپردن رمز عبور ندارید،‌ شما هر بار که بخواهید سفارش خود را ثبت کنید کافیست یک شماره موبایل وارد کرده تا رمز عبور برای شما پیامک شود.' +
        '                        <br>' +
        '                        <br>' +
        '                        ۹. سامانه اجاق در تلاش است از حریم شخصی کاربران محافظت کند تا بتوانند خریدی امن و راحت را تجربه کنند.' +
        '' +
        '                    </p></div>');

    TraceNodes(document);
}

function profilePageInit() {
    $$('.backToHome').on('click', async function() {
        refreshApp();
    });

    if(user.mobile !== null) {
        $$('input.phoneNumber').val(''+ user.mobile +'');
    } else {
        $$('input.phoneNumber').val('');
    }

    if(user.firstName !== null) {
        $$('input.firstName').val(''+ user.firstName +'');
    } else {
        $$('input.firstName').val('');
    }

    if(user.lastName !== null) {
        $$('input.lastName').val(''+ user.lastName +'');
    } else {
        $$('input.lastName').val('');
    }

    $$('.profile-save').on('click', async function () {
        $$(this).css('pointer-events', 'none');
        $$(this).html('صبر کنید');

        var firstName = $$('input.firstName').val();
        var lastName = $$('input.lastName').val();

        await user.editProfile(firstName, lastName);

    });
}