// Create dynamic Popup
var dynamicPopup = app.popup.create({
    content: '<div class="popup address-popup">'+
    '<div class="block">'+
    '<p><h3 style="display: inline-block">افزودن آدرس</h3>' +
    '<i class="f7-icons link popup-close" style="position:relative;float:left;top: 10px;cursor: pointer;">close</i></p>' +
    '<div class="row"><div class="col-50"><input type="text" class="addressName" placeholder="عنوان آدرس" /></div>' +
    '<div class="col-50"><input type="number" maxlength="16" class="addressPhone" placeholder="تلفن" /></div>' +
    '<input readonly required id="locationName" class="AddresslocationName" placeholder="آدرس خودکار(با حرکت روی نقشه این قسمت تکمیل می‌شود)" />' +
    '<textarea class="addressContent" rows="3" required placeholder="ادامه آدرس..."></textarea>' +
    '</div>' +
    '<div class="row"><div id="map"></div><div id="map_marker"></div></div>'+
    '<p style="text-align: center;"><a class="btn btn-block cart-btn save-address">ثبت آدرس</a></p>'+
    '</div>'+
    '</div>',
    // Events
    on: {
        opened: function (popup) {

            if(platform != 'browser') {
                var dragHandle = false;
                var gestureHandle = true;
            }

            if (firstMap) {

                var map = new Mapp({
                    element: '#map',
                    presets: {
                        latlng: {
                            lat: 35.793191,
                            lng: 51.454569,
                        },
                        zoom: 11
                    },
                    apiKey: mapApiKey,
                    dragging: dragHandle,
                    gestureHandling: gestureHandle
                });

                map.addLayers();

                map.addDynamicLocation({
                    format: 'latlng',
                    source: 'center',
                });

                firstMap = false;
            }

            var sLat = '';
            var sLng = '';

            $( "#map" ).bind("mouseup touchend", async function() {

                var addressLocation = ($('.mapp-location input').val()).split(', ');
                sLat = addressLocation[0];
                sLng = addressLocation[1];
                var locationData = await user.getUserLocationName(sLat, sLng);
                $$('input#locationName').val(getLocationName(locationData));

            });

            var url = baseUrl +'/api/v1/address/add';

            $$(document).on('click', '.save-address', function() {

                if (handleLastSubmit()) return false;

                let pageName = app.views.main.router.currentRoute.name;

                $$(this).css('pointer-events', 'none');
                $$(this).html('صبر کنید');

                var addressTitle = $$('input.addressName').val();
                var addressPhone = $$('input.addressPhone').val();
                var addressAddress = $$('input.AddresslocationName').val();
                var addressContent = $$('textarea.addressContent').val();

                if (addressAddress == "") {
                    autoAddressEmpty.open();

                    $$(this).css('pointer-events', 'all');
                    $$(this).html('ذخیره');

                    return false;
                } else if (addressContent == "") {
                    completeAddressEmpty.open();

                    $$(this).css('pointer-events', 'all');
                    $$(this).html('ذخیره');

                    return false;
                }

                addressContent = addressAddress + '، ' + addressContent;

                var data = new FormData();
                data.append("platform", platform);
                data.append("version", appVersion);
                data.append("address[lat]", sLat);
                data.append("address[lon]", sLng);
                data.append("address[title]", addressTitle);
                data.append("address[address]", addressContent);
                data.append("address[phone]", addressPhone);

                var settings = {
                    async: true,
                    crossDomain: crossDomainParam,
                    url: url,
                    method: "POST",
                    headers: {
                        "X-AUTH-TOKEN": user.confirmationToken,
                        "X-AUTH-MOBILE": user.mobile,
                        "cache-control": "no-cache"
                    },
                    processData: false,
                    contentType: false,
                    mimeType: "multipart/form-data",
                    data: data
                };

                $.ajax(settings).done(async function (response) {

                    try {

                        let blocker = await user.startup(false);

                        if (pageName === 'choose-address') {
                            let availableAddresses = await checkAvailableAddresses();

                            if(availableAddresses.code == 100) {
                                let foodMenu = JSON.parse(window.localStorage.getItem("foodMenu"));
                                dynamicPopup.close();

                                chooseAddressPageInit(null, foodMenu, availableAddresses.availableAddresses);
                            } else {
                                refreshApp();
                            }
                        } else {
                            renderAddresses(user.userData.user.data['addresses'], false, true);

                            window.localStorage.setItem("lat", sLat);
                            window.localStorage.setItem("lng", sLng);

                            dynamicPopup.close();
                        }

                    } catch (e) {
                        refreshApp();
                    }

                    $$('.save-address').css('pointer-events', 'all');
                    $$('.save-address').html('ذخیره');

                    $$('input.addressName').val('');
                    $$('input.addressPhone').val('');
                    $$('input.AddresslocationName').val('');
                    $$('textarea.addressContent').val('');

                }).fail(function(response) {
                    noInternet.open();

                    $$('.save-address').css('pointer-events', 'all');
                    $$('.save-address').html('ذخیره');
                });

            });

        },
    }
});

// Events also can be assigned on instance later
dynamicPopup.on('close', function (popup) {
    // console.log('Popup close');
});

dynamicPopup.on('closed', function (popup) {
    // console.log('Popup closed');
});

var forceUpdatePopUp = app.popup.create({
    content: '<div class="popup">'+
    '<div class="block">'+
    '<p><h3 style="display: inline-block">به‌روزرسانی جدید</h3>' +
    '</p>' +
    '<p style="text-align: center;margin-bottom: 80px;font-size: 17px;padding: 40px;line-height: 30px;"> به‌روزرسانی جدید برای اپلیکیشن اجاق در دسترس است. برای ادامه استفاده از اپلیکیشن روی دکمه زیر بزن' +
    '</p>' +
    '<p style="text-align: center;"><a class="btn btn-block cart-btn updateLink external">به‌روزرسانی اجاق</a></p>'+
    '</div>'+
    '</div>',
    // Events
    on: {
        open: function (popup) {
            // console.log('Popup open');
        },
        opened: function (popup) {
            // console.log('Popup opened');
        },
    }
});

var availableUpdatePopUp = app.popup.create({
    content: '<div class="popup">'+
    '<div class="block">'+
    '<p><h3 style="display: inline-block">به‌روزرسانی جدید</h3>' +
    '<i class="f7-icons link popup-close updatePopUpStatus" style="position:relative;float:left;top: 10px;cursor: pointer;">close</i></p>' +
    '<p style="text-align: center;margin-bottom: 80px;font-size: 17px;padding: 40px;line-height: 30px;"> در صورت تمایل می‌توانید اپلیکیشن اجاق را از طریق دکمه زیر به‌روزرسانی کنید.' +
    '</p>' +
    '<p style="text-align: center;"><a class="btn btn-block cart-btn updateLink external">به‌روزرسانی اجاق</a></p>'+
    '</div>'+
    '</div>',
    // Events
    on: {
        open: function (popup) {
            // console.log('Popup open');
        },
        opened: function (popup) {
            // console.log('Popup opened');
        },
    }
});

var preorder = app.popup.create({
    content: '<div class="popup">'+
    '<div class="block">'+
    '<p><h3 style="display: inline-block">انتخاب زمان دریافت سفارش</h3>' +
    '<i class="f7-icons link popup-close updatePopUpStatus" style="position:relative;float:left;top: 10px;cursor: pointer;">close</i></p>' +
    '<p style="text-align: center;margin-bottom: 10px;font-size: 14px;padding: 40px;line-height: 30px;" class="preorderText"></p>' +
    '<div class="pre-order-times"></div>' +
    '</div>'+
    '</div>',
    // Events
    on: {
        close: function(popup) {
            // refreshApp();
        },
        open: function (popup) {
            // console.log('Popup open');
        },
        opened: function (popup) {
            let preorderId = window.localStorage.getItem("preorderId");
                $$('.preorderText').html('لطفا زمان مورد نظر خود را برای دریافت سفارش انتخاب کنید');
                let preOrderHtml = '<p style="text-align: center;border-bottom: 1px solid #e3e3e3;margin-bottom: 20px;padding-bottom: 23px;"><a class="btn btn-block order-button ' +
                    ((preorderId === '') ? "active-preorder" : "") +
                    '"> ' +
                    ((preorderId === '') ? "<i class=\"f7-icons check-icon \">check</i>" : "") +
                    'همین الان' +
                    '</a></p>';
                Object.keys(user.preorderTimes).forEach(function(key) {
                    var item =  user.preorderTimes[key];
                    // console.log(item);

                    if(item.timePassed == false) {
                        if(item.capacity > 0) {
                            preOrderHtml += '<p style="text-align: center;"><a class="btn btn-block preorder-button ' +
                                ((preorderId == item.id) ? "active-preorder" : "") +
                                '" item-id="'+ item.id +'"> ' +
                                ((preorderId == item.id) ? "<i class=\"f7-icons check-icon \">check</i>" : "") +
                                '' + item.start + '' +
                                ' الی ' + item["end"] + '</a></p>';
                        } else if (item.capacity == 0) {
                            preOrderHtml += '<p style="text-align: center"><a class="btn btn-block preorder-button-off preorder-capacity-notif" item-id="'+ item.id +'">' +
                                '' + item.start + '-' + item.end + ' '
                            '</a></p>';
                        }
                    } else {
                        preOrderHtml += '<p style="text-align: center"><a class="btn btn-block preorder-button-off preorder-time-notif" item-id="'+ item.id +'">' +
                            '' + item.start + '-' + item.end + ' '
                        '</a></p>';
                    }
                });
                $$('.pre-order-times').html(preOrderHtml);
                TraceNodes(document);

                $$(document).on('click', '.preorder-button', function () {
                    var id = $$(this).attr('item-id');
                    window.localStorage.setItem("preorderId", id);
                    window.localStorage.setItem("cart", '[]');
                    refreshApp();
                });

            // }
            $$(document).on('click','.order-button', function () {
                window.localStorage.setItem("preorderId", '');
                window.localStorage.setItem("cart", '[]');
                refreshApp();
            });

            $$(document).on('click', '.preorder-capacity-notif', function(){
                preorderCapacityNotif.open();
            });

            $$(document).on('click', '.preorder-time-notif', function(){
                preorderTimeNotif.open();
            });
        },
    }
});

var iosAddToScreenHelp = app.popup.create({
    content: '<div class="popup">'+
    '<div class="block">'+
    '<p><h3 style="display: inline-block">وب‌اپلیکیشن اجاق را به صفحه اصلی موبایل خود اضافه کنید</h3>' +
    '<i class="f7-icons link popup-close updatePopUpStatus" style="position:relative;float:left;top: 10px;cursor: pointer;">close</i></p>' +
    '<p style="text-align: center;margin-bottom: 80px;font-size: 16px;padding: 30px;line-height: 40px;" class="preorderText">' +
    '۱. در نوار پایین دکمه ' +
    '<img style="max-width: 20px;position: relative;top: 3px;" src="img/icon-share.png" alt="" />' +
    ' را انتخاب کنید.' +
    '<br />' +
    '۲. منوی بازشده را به چپ بکشید و گزینه ' +
    '<b>Add to home screen </b>' +
    'را انتخاب کنید.' +
    '<br />' +
    '<img style="max-height: 90px;" src="img/add-to-home-screen.png" alt="">' +
    '<br />' +
    '۳. در قسمت بعد روی ' +
    '<b>Add </b>' +
    'یا ' +
    '<b>Save </b>' +
    'کلیک کنید.' +
    '</p>' +
    '</div>'+
    '</div>',
    // Events
    on: {
        close: function(popup) {

        },
        open: function (popup) {

        },
        opened: function (popup) {

        },
    }
});