class User {

    constructor() {
        this.mobile = "";
        this.confirmationToken = "";
        this.isLoggedIn = false;
        this.userData = {};
        this.wallet = '';
        this.name = '';
        this.firstName = '';
        this.lastName = '';
        this.appVersionStatus = '';
        this.appVersionStatusRequired = '';
        this.appVersionStatusLink = '';
        this.shippment_Price = '';
        this.packaging_Price = '';
        this.preorderTimes = {};
        this.invoices = {};
    }

    async startup(showPreLoader=true) {

        if (showPreLoader) app.preloader.show('orange');

        let storageData = await this.loadUser();

        if (storageData['mobile'] !== null && storageData['confirmationToken'] !== null && storageData['mobile'] !== '' && storageData['confirmationToken'] !== '') {

            var userData = await this.getUserData(storageData['mobile'], storageData['confirmationToken']);

            if (userData !== false && userData !== null && userData !== '' && userData !== undefined) {

                if(userData.versionStatus !== false && userData.versionStatus !== null &&
                    userData.versionStatus !== '' && userData.versionStatus !== undefined) {

                    this.appVersionStatus = userData.versionStatus.status;
                    this.appVersionStatusRequired = userData.versionStatus.required;
                    this.appVersionStatusLink = userData.versionStatus.link;

                    shippmentPrice = userData.shipment_price;
                    packagingPrice = userData.packaging_price;
                    canOrderNow = userData.can_order_now;

                    if (this.appVersionStatus === 'newVersion' && this.appVersionStatusRequired === true) {

                        forceUpdatePopUp.open();
                        localStorage.clear();
                        $$('.updateLink').attr('href', this.appVersionStatusLink);

                    } else {

                        let seenUpdateTimestamp = window.localStorage.getItem("seenUpdateTimestamp");

                        if(seenUpdateTimestamp == undefined || seenUpdateTimestamp == '' || seenUpdateTimestamp == null || seenUpdateTimestamp == 'null') {

                            if (this.appVersionStatus === 'newVersion' && this.appVersionStatusRequired === false) {

                                availableUpdatePopUp.open();

                                $$('.updateLink').attr('href', this.appVersionStatusLink);

                                $$(document).on('click', '.updatePopUpStatus', function(){
                                    let currentUnixTime = Math.round(new Date().getTime()/1000);
                                    window.localStorage.setItem('seenUpdateTimestamp', currentUnixTime);
                                });

                            }

                        } else {

                            let now = Math.round(new Date().getTime()/1000);
                            let aDayInSeconds = 86400;
                            let diffTime = now - seenUpdateTimestamp;

                            if(diffTime < aDayInSeconds) {

                                availableUpdatePopUp.open();

                                $$('.updateLink').attr('href', this.appVersionStatusLink);

                                $$(document).on('click', '.updatePopUpStatus', function(){
                                    let currentUnixTime = Math.round(new Date().getTime()/1000);
                                    window.localStorage.setItem('seenUpdateTimestamp', currentUnixTime);
                                });

                            }

                        }

                        this.mobile = storageData['mobile'];
                        this.confirmationToken = storageData['confirmationToken'];
                        this.userData = userData;
                        this.preorderTimes = userData.preOrderPeriods;
                        this.invoices = userData.user.invoices;
                        if( this.preorderTimes == undefined || this.preorderTimes == '' || this.preorderTimes == null ||
                            this.preorderTimes == {} || this.preorderTimes == [] ) {
                            window.localStorage.setItem('preorderId', '');
                        }

                        this.wallet = (userData.user.data['wallet'] !== undefined && userData.user.data['wallet'] !== '') ? userData.user.data['wallet'] : '0';

                        this.name = (userData.user.fullName !== undefined && userData.user.fullName !== '') ? userData.user.fullName : this.mobile;
                        this.firstName = (userData.user.firstName !== undefined && userData.user.firstName !== '') ? userData.user.firstName : '';
                        this.lastName = (userData.user.lastName !== undefined && userData.user.lastName !== '') ? userData.user.lastName : '';

                        this.isLoggedIn = true;

                    }

                }

            }
        } else {

            this.isLoggedIn = false;

        }

    }

    async loadUser() {

        let mobile = window.localStorage.getItem("mobile");
        let confirmationToken = window.localStorage.getItem("confirmationToken");

        return {
            mobile: mobile,
            confirmationToken: confirmationToken
        };

    }

    async getUserData(mobile, confirmationToken) {

        var url = baseUrl +'/api/v1/get-user';

        var data = new FormData();
        data.append("platform", platform);
        data.append("version", appVersion);

        var settings = {
            async: true,
            crossDomain: crossDomainParam,
            url: url,
            dataType: "json",
            method: "POST",
            headers: {
                "X-AUTH-TOKEN": confirmationToken,
                "X-AUTH-MOBILE": mobile
            },
            processData: false,
            contentType: false,
            mimeType: "multipart/form-data",
            data: data
        };

        return $.ajax(settings).done(function (response) {

            return response;

        }).fail(function(response, status, error) {

            if(response.status == '403') {

                localStorage.clear();
                refreshApp();

            } else {

                noInternet.open();

                setTimeout( function() {
                        refreshApp();
                    }, 10000
                );

            }

        });
    }

    login(mobile, callback) {
        var url = baseUrl +'/api/v1/login';

        var data = new FormData();
        data.append("mobile", mobile);
        data.append("version", appVersion);
        data.append("platform", platform);

        var settings = {
            async: true,
            crossDomain: crossDomainParam,
            url: url,
            dataType: "json",
            method: "POST",
            headers: {
                "cache-control": "no-cache",
            },
            processData: false,
            contentType: false,
            mimeType: "multipart/form-data",
            data: data
        }

        $.ajax(settings).done(function (response) {
            window.localStorage.setItem("mobile", mobile);
            callback(response);
        }).fail(function(response) {
            $$('.btn-login').css('pointer-events', 'all');
            $$('.btn-login').html('ورود');

            // let responseText = response.statusText;
            // let responseText = JSON.parse(response);

            // alert(responseText);

            noInternet.open();
        });
    }

    confirmCode(mobile, codeStrEn, callback) {
        var url = baseUrl +'/api/v1/login-confirm';

        var data = new FormData();
        data.append("mobile", mobile);
        data.append("code", codeStrEn);
        data.append("version", appVersion);

        var settings = {
            async: true,
            crossDomain: crossDomainParam,
            url: url,
            dataType: "json",
            method: "POST",
            headers: {
                "cache-control": "no-cache",
            },
            processData: false,
            contentType: false,
            mimeType: "multipart/form-data",
            data: data
        }

        $.ajax(settings).done(function (response) {
            callback(response);
        }).fail(function(response) {

            $$('.inputs-box').removeClass('blur-loading');
            noInternet.open();

            $$('.code-inputs').val('');
            $$("#firstCodeInput").focus();
        });
    }

    editProfile(firstName, lastName) {
        var url = baseUrl +'/api/v1/profile/edit';

        var data = new FormData();
        data.append("platform", platform);
        data.append("version", appVersion);
        data.append("name", firstName);
        data.append("surname", lastName);
        data.append("birthDate", "1992-06-11");
        data.append("gender", "male");

        var settings = {
            async: true,
            crossDomain: crossDomainParam,
            url: url,
            dataType: "json",
            method: "POST",
            headers: {
                "X-AUTH-TOKEN": user.confirmationToken,
                "X-AUTH-MOBILE": user.mobile
            },
            processData: false,
            contentType: false,
            mimeType: "multipart/form-data",
            data: data
        }

        $.ajax(settings).done(function (response) {
            $$('.profile-save').css('pointer-events', 'all');
            $$('.profile-save').html('ذخیره');
            // console.log(response);

            dynamicPopover.close();

            user.firstName = firstName;
            user.latName = lastName;

            user.name = firstName +' '+ lastName;

            renderSidebarData();
        }).fail(function(response) {
            noInternet.open();

            $$('.profile-save').css('pointer-events', 'all');
            $$('.profile-save').html('ذخیره');
        });
    }

    loadUserLocation() {

        let storageLat = window.localStorage.getItem('lat');
        let storageLng = window.localStorage.getItem('lng');
        let storageSelectedAddress = window.localStorage.getItem('selectedAddress');

        return {
            lat: storageLat,
            lng: storageLng,
            selectedAddress: storageSelectedAddress
        };

    }

    getUserLocationName(lat, lng) {

        var url = 'https://map.ir/fast-reverse';

        // var text = $$('input.location-search-name').val();

        return $.ajax({
            method: 'GET',
            headers: {
                'x-api-key': mapApiKey
            },
            data: {
                "lat" : lat,
                "lon" : lng
            },
            url: url,
            success: function (response) {

                return response;

            }
        });
    }

    async deleteAddress(id) {

        var url = baseUrl +'/api/v1/address/delete';
        var data = new FormData();
        data.append("index", id);
        data.append("platform", platform);
        data.append("version", appVersion);

        var settings = {
            async: true,
            crossDomain: crossDomainParam,
            url: url,
            dataType: "json",
            method: "POST",
            headers: {
                "X-AUTH-TOKEN": user['confirmationToken'],
                "X-AUTH-MOBILE": user['mobile']
            },
            processData: false,
            contentType: false,
            mimeType: "multipart/form-data",
            data: data
        };

        return $.ajax(settings).done(function (response) {

            if (response['code'] == 100) return true;
            else return false;

        }).fail(function(response, status, error) {

            return false;

        });

    }

}
